Main Page Widgets Namespaces Book

# Gtk::Widget Class Reference

Inheritance diagram for Gtk::Widget:

[legend]

List of all members.

## Detailed Description

Abstract Widget (Base class for all widgets).

As the base class of all widgets this contains all of the properties and methods common to all widgets. It is an abstract class that can not be instantiated.

Important part of widgets are the *_event signals and virtual methods that every widget have. Those are events coming directly from gdk and thus also from XLib. By overriding those virtual methods you can trap everything a widget can ever do. In order to capture events from a widget, the event mask must first be set with ().

Only widgets with a Gdk::Window on the server side are allowed to capture events. Widgets in the Gtk::Misc group for example lack a Gdk::Window.

## Public Member Functions

bool | activate ()
| For widgets that can be "activated" (buttons, menu items, etc.
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr<AccelGroup>& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget.
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget.
void | add_modal_grab ()
| Block events to everything else than this widget and its children.
bool | app_paintable () const
bool | can_default () const
bool | can_focus () const
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::child-notify signal for the child property child_property on widget.
void | class_path (Glib::ustring& path, Glib::ustring& path_reversed)
Glib::RefPtr<Pango::Context> | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget.
Glib::RefPtr<Pango::Layout> | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.
bool | double_buffered () const
Glib::RefPtr<Gdk::DragContext> | drag_begin (const Glib::RefPtr<TargetList>& targets, Gdk::DragAction actions, int button, GdkEvent* event)
| Initiates a drag on the source side.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation.
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag destination.
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag destination.
Glib::ustring | drag_dest_find_target (const Glib::RefPtr<Gdk::DragContext>& context) const
Glib::ustring | drag_dest_find_target (const Glib::RefPtr<Gdk::DragContext>& context, const Glib::RefPtr<TargetList>& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE.
Glib::RefPtr<const TargetList> | drag_dest_get_target_list () const
| Return value: the Gtk::TargetList, or `0` if none.
Glib::RefPtr<TargetList> | drag_dest_get_target_list ()
| Return value: the Gtk::TargetList, or `0` if none.
void | drag_dest_set (const ArrayHandle_TargetEntry& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set_proxy (const Glib::RefPtr<Gdk::Window>& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
void | drag_dest_set_target_list (const Glib::RefPtr<TargetList>& target_list)
| Sets the target types that this widget can accept from drag-and-drop.
void | drag_dest_unset ()
void | drag_get_data (const Glib::RefPtr<Gdk::DragContext>& context, const Glib::ustring& target, guint32 time)
void | drag_get_data (const Glib::RefPtr<Gdk::DragContext>& context, Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_set_as_icon (const Glib::RefPtr<Gdk::DragContext>& context, int hot_x, int hot_y)
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::Selection to the target list of the drag source.
void | drag_source_set (const ArrayHandle_TargetEntry& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon.
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon.
void | drag_source_set_icon (const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf.
void | drag_source_set_icon (const Glib::RefPtr<Gdk::Colormap>& colormap, const Glib::RefPtr<Gdk::Pixmap>& pixmap, const Glib::RefPtr<Gdk::Bitmap>& mask)
| Sets the icon that will be used for drags from a particular widget from a pixmap/mask.
void | drag_source_unset ()
void | drag_unhighlight ()
void | draw_insertion_cursor (Glib::RefPtr<Gdk::Drawable> drawable, const Gdk::Rectangle& area, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
void | ensure_style ()
| Ensures that widget has a style ( widget->style).
void | error_bell ()
| Notifies the user about an input-related error on this widget.
bool | event (GdkEvent* event)
| Rarely-used function.
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::child-notify signals on widget.
Glib::RefPtr<Atk::Object> | get_accessible ()
| Returns: the Atk::Object associated with widget.
Glib::RefPtr<const Action> | get_action () const
| Returns: the action that a widget is a proxy for, or.
Glib::RefPtr<Action> | get_action ()
| Returns: the action that a widget is a proxy for, or.
Allocation | get_allocation () const
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
Glib::RefPtr<const Clipboard> | get_clipboard (const Glib::ustring& selection) const
| Return value: the appropriate clipboard object.
Glib::RefPtr<Clipboard> | get_clipboard (const Glib::ustring& selection)
| Return value: the appropriate clipboard object.
Glib::RefPtr<Gdk::Colormap> | get_colormap ()
| Gets the colormap that will be used to render widget.
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
TextDirection | get_direction ()
| Gets the reading direction for a particular widget.
Glib::RefPtr<const Gdk::Display> | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget.
Glib::RefPtr<Gdk::Display> | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget.
Gdk::EventMask | get_events () const
| Return value: event mask for widget.
Gdk::ExtensionMode | get_extension_events () const
| Retrieves the extension events the widget will receive; see gdk_input_set_extension_events().
WidgetFlags | get_flags () const
bool | get_has_tooltip () const
| Return value: current value of has-tooltip on widget.
int | get_height () const
Glib::RefPtr<const RcStyle> | get_modifier_style () const
| Return value: the modifier style for the widget.
Glib::RefPtr<RcStyle> | get_modifier_style ()
| Return value: the modifier style for the widget.
Glib::ustring | get_name () const
| Retrieves the name of a widget.
bool | get_no_show_all () const
| Return value: the current value of the "no-show-all" property.
Glib::RefPtr<Pango::Context> | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.
const Container* | get_parent () const
| Return value: the parent container of widget, or `0`.
Container* | get_parent ()
| Return value: the parent container of widget, or `0`.
Glib::RefPtr<const Gdk::Window> | get_parent_window () const
| Gets widget's parent window.
Glib::RefPtr<Gdk::Window> | get_parent_window ()
| Gets widget's parent window.
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates.
Requisition | get_requisition () const
Glib::RefPtr<const Gdk::Window> | get_root_window () const
| Get the root window where this widget is located.
Glib::RefPtr<Gdk::Window> | get_root_window ()
| Get the root window where this widget is located.
Gtk::StateType | get_saved_state () const
Glib::RefPtr<const Gdk::Screen> | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget.
Glib::RefPtr<Gdk::Screen> | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget.
Glib::RefPtr<Settings> | get_settings ()
| Gets the settings object holding the settings (global property settings, RC file information, etc) used for this widget.
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
Glib::RefPtr<Gdk::Pixmap> | get_snapshot () const
| Create a Gdk::Pixmap of the contents of the widget and its children.
Glib::RefPtr<Gdk::Pixmap> | get_snapshot (Gdk::Rectangle& clip_rect) const
Gtk::StateType | get_state () const
Glib::RefPtr<const Style> | get_style () const
| Simply an accessor function that returns widget->style.
Glib::RefPtr<Style> | get_style ()
| Simply an accessor function that returns widget->style.
template<class PropertyType>
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
Window* | get_tooltip_window ()
| Return value: The Gtk::Window of the current tooltip.
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of.
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of.
Glib::RefPtr<Gdk::Visual> | get_visual ()
| Gets the visual that will be used to render widget.
int | get_width () const
Glib::RefPtr<const Gdk::Window> | get_window () const
Glib::RefPtr<Gdk::Window> | get_window ()
const GtkWidget* | gobj () const
| Provides access to the underlying C GtkObject.
GtkWidget* | gobj ()
| Provides access to the underlying C GtkObject.
void | grab_default ()
| Causes widget to become the default widget.
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside.
bool | has_default () const
bool | has_focus () const
bool | has_grab () const
bool | has_no_window () const
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget.
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user).
void | hide_all ()
| Recursively hides a widget and any child widgets.
void | input_shape_combine_mask (const Glib::RefPtr<const Gdk::Bitmap>& shape_mask, int offset_x, int offset_y)
| Sets an input shape for this widget's GDK window.
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection.
bool | intersect (const Gdk::Rectangle& area) const
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | is_composite_child () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly.
bool | is_drawable () const
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | is_mapped () const
bool | is_realized () const
bool | is_sensitive () const
bool | is_toplevel () const
bool | is_visible () const
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary.
Glib::ListHandle<const Widget*> | list_mnemonic_labels () const
| Return value: the list of mnemonic labels; free this list.
Glib::ListHandle<Widget*> | list_mnemonic_labels ()
| Return value: the list of mnemonic labels; free this list.
void | map ()
| This function is only for use in widget implementations.
bool | mnemonic_activate (bool group_cycling)
void | modify_base (StateType state, const Gdk::Color& color)
| Sets the base color for a widget in a particular state.
void | modify_bg (StateType state, const Gdk::Color& color)
| Sets the background color for a widget in a particular state.
void | modify_bg_pixmap (StateType state, const Glib::ustring& pixmap_name)
void | modify_cursor (const Gdk::Color& primary, const Gdk::Color& secondary)
| Sets the cursor color to use in a widget, overriding the cursor_color and secondary_cursor_color style properties.
void | modify_fg (StateType state, const Gdk::Color& color)
| Sets the foreground color for a widget in a particular state.
void | modify_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget.
void | modify_style (const Glib::RefPtr<RcStyle>& style)
| Modifies style values on the widget.
void | modify_text (StateType state, const Gdk::Color& color)
| Sets the text color for a widget in a particular state.
bool | parent_sensitive () const
void | path (Glib::ustring& path, Glib::ustring& path_reversed)
| Compute a widget's path of the form "GtkWindow.MyLabel".
Glib::PropertyProxy_ReadOnly <bool> | property_app_paintable () const
| Whether the application will paint directly on the widget.
Glib::PropertyProxy<bool> | property_app_paintable ()
| Whether the application will paint directly on the widget.
Glib::PropertyProxy_ReadOnly <bool> | property_can_default () const
| Whether the widget can be the default widget.
Glib::PropertyProxy<bool> | property_can_default ()
| Whether the widget can be the default widget.
Glib::PropertyProxy_ReadOnly <bool> | property_can_focus () const
| Whether the widget can accept the input focus.
Glib::PropertyProxy<bool> | property_can_focus ()
| Whether the widget can accept the input focus.
Glib::PropertyProxy_ReadOnly <bool> | property_composite_child () const
| Whether the widget is part of a composite widget.
Glib::PropertyProxy_ReadOnly <Gdk::EventMask> | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy <Gdk::EventMask> | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets.
Glib::PropertyProxy_ReadOnly <Gdk::ExtensionMode> | property_extension_events () const
| The mask that decides what kind of extension events this widget gets.
Glib::PropertyProxy <Gdk::ExtensionMode> | property_extension_events ()
| The mask that decides what kind of extension events this widget gets.
Glib::PropertyProxy_ReadOnly <bool> | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy<bool> | property_has_default ()
| Whether the widget is the default widget.
Glib::PropertyProxy_ReadOnly <bool> | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy<bool> | property_has_focus ()
| Whether the widget has the input focus.
Glib::PropertyProxy_ReadOnly <bool> | property_has_tooltip () const
| Whether this widget has a tooltip.
Glib::PropertyProxy<bool> | property_has_tooltip ()
| Whether this widget has a tooltip.
Glib::PropertyProxy_ReadOnly<int> | property_height_request () const
| Override for height request of the widget.
Glib::PropertyProxy<int> | property_height_request ()
| Override for height request of the widget.
Glib::PropertyProxy_ReadOnly <Glib::ustring> | property_name () const
| The name of the widget.
Glib::PropertyProxy <Glib::ustring> | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly <Container*> | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy<Container*> | property_parent ()
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly <bool> | property_receives_default () const
| If TRUE.
Glib::PropertyProxy<bool> | property_receives_default ()
| If TRUE.
Glib::PropertyProxy_ReadOnly <bool> | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy<bool> | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly <Glib::RefPtr<Style>> | property_style () const
| The style of the widget.
Glib::PropertyProxy <Glib::RefPtr<Style>> | property_style ()
| The style of the widget.
Glib::PropertyProxy_ReadOnly <Glib::ustring> | property_tooltip_markup () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy <Glib::ustring> | property_tooltip_markup ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly <Glib::ustring> | property_tooltip_text () const
| The contents of the tooltip for this widget.
Glib::PropertyProxy <Glib::ustring> | property_tooltip_text ()
| The contents of the tooltip for this widget.
Glib::PropertyProxy_ReadOnly <bool> | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy<bool> | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly<int> | property_width_request () const
| Override for width request of the widget.
Glib::PropertyProxy<int> | property_width_request ()
| Override for width request of the widget.
Glib::PropertyProxy_ReadOnly <Glib::RefPtr<Gdk::Window>> | property_window () const
| The widget's window if it is realized.
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget.
void | queue_draw_area (int x, int y, int width, int height)
| Invalidates the rectangular area of widget defined by x, y, width and height by calling gdk_window_invalidate_rect() on the widget's window and all its child windows.
void | queue_resize ()
| This function is only for use in widget implementations.
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated.
bool | rc_style () const
bool | receives_default () const
Gdk::Region | region_intersect (const Gdk::Region& region) const
| Computes the intersection of a widget's area and region, returning the intersection.
bool | remove_accelerator (const Glib::RefPtr<AccelGroup>& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator().
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget.
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed.
Glib::RefPtr<Gdk::Pixbuf> | render_icon (const StockID& stock_id, IconSize size, const Glib::ustring& detail=Glib::ustring())
| A convenience function that uses the theme engine and RC file settings for the widget to look up stock_id and render it to a pixbuf.
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.
void | reset_rc_styles ()
void | reset_shapes ()
| Recursively resets the shape on this widget and its descendants.
int | send_expose (GdkEvent* event)
| Very rarely-used function.
bool | sensitive () const
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr<AccelGroup>& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::expose-event handler.
void | set_child_visible (bool is_visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().
void | set_colormap (const Glib::RefPtr<const Gdk::Colormap>& colormap)
| Sets the colormap for the widget to the given value.
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering.
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget.
void | set_extension_events (Gdk::ExtensionMode mode)
| Sets the extension events mask to mode.
void | set_flags (WidgetFlags flags)
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip.
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a gtkrc file.
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget:no-show-all property, which determines whether calls to show_all() and hide_all() will affect this widget.
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container.
void | set_parent_window (const Glib::RefPtr<const Gdk::Window>& parent_window)
| Sets a non default parent window for widget.
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes.
bool | set_scroll_adjustments (Adjustment& hadjustment, Adjustment& vadjustment)
| For widgets that support scrolling, sets the scroll adjustments and Return value: `true` if the widget supports scrolling.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget's size request will be width by height.
void | set_state (Gtk::StateType state)
| This function is for use in widget implementations.
void | set_style (const Glib::RefPtr<Style>& style)
| Sets the Gtk::Style for a widget ( widget->style).
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip.
void | set_tooltip_window (Window& widget)
| Replaces the default, usually yellow, window used for displaying tooltips with custom_window.
void | shape_combine_mask (const Glib::RefPtr<const Gdk::Bitmap>& shape_mask, int offset_x, int offset_y)
| Sets a shape for this widget's GDK window.
void | show ()
| Flags a widget to be displayed.
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container).
void | show_now ()
| Shows a widget.
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_press_event ()
Glib::SignalProxy1< bool, GdkEventButton* > | signal_button_release_event ()
Glib::SignalProxy1< void, GParamSpec* > | signal_child_notify ()
| The child-notify signal is emitted for each child property that has changed on an object.
Glib::SignalProxy1< bool, GdkEventClient* > | signal_client_event ()
Glib::SignalProxy0<void> | signal_composited_changed ()
Glib::SignalProxy1< bool, GdkEventConfigure* > | signal_configure_event ()
Glib::SignalProxy1< bool, GdkEventExpose* > | signal_damage_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_delete_event ()
| The delete_event signal is emitted if a user requests that a toplevel window is closed.
Glib::SignalProxy1< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy1< void, const Glib::RefPtr <Gdk::DragContext >&> | signal_drag_begin ()
| The drag_begin signal is emitted on the drag source when a drag is started.
Glib::SignalProxy1< void, const Glib::RefPtr <Gdk::DragContext >&> | signal_drag_data_delete ()
| The drag_data_delete signal is emitted on the drag source when a drag with the action Gdk::ACTION_MOVE is successfully completed.
Glib::SignalProxy4< void, const Glib::RefPtr <Gdk::DragContext> &, SelectionData&, guint, guint > | signal_drag_data_get ()
| The drag_data_get signal is emitted on the drag source when the drop site requests the data which is dragged.
Glib::SignalProxy6< void, const Glib::RefPtr <Gdk::DragContext>&, int, int, const SelectionData &, guint, guint > | signal_drag_data_received ()
| The drag_data_received signal is emitted on the drop site when the dragged data has been received.
Glib::SignalProxy4< bool, const Glib::RefPtr <Gdk::DragContext>&, int, int, guint > | signal_drag_drop ()
| The drag_drop signal is emitted on the drop site when the user drops the data onto the widget.
Glib::SignalProxy1< void, const Glib::RefPtr <Gdk::DragContext >&> | signal_drag_end ()
| The drag_end signal is emitted on the drag source when a drag is finished.
Glib::SignalProxy2< bool, const Glib::RefPtr <Gdk::DragContext> &, DragResult > | signal_drag_failed ()
Glib::SignalProxy2< void, const Glib::RefPtr <Gdk::DragContext >&, guint> | signal_drag_leave ()
| The drag_leave signal is emitted on the drop site when the cursor leaves the widget.
Glib::SignalProxy4< bool, const Glib::RefPtr <Gdk::DragContext>&, int, int, guint > | signal_drag_motion ()
| The drag_motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag.
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_enter_notify_event ()
Glib::SignalProxy1< bool, GdkEvent* > | signal_event ()
Glib::SignalProxy1< void, GdkEvent* > | signal_event_after ()
Glib::SignalProxy1< bool, GdkEventExpose* > | signal_expose_event ()
Glib::SignalProxy1< bool, DirectionType > | signal_focus ()
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_in_event ()
Glib::SignalProxy1< bool, GdkEventFocus* > | signal_focus_out_event ()
Glib::SignalProxy0 <Glib::RefPtr<Atk::Object>> | signal_get_accessible ()
Glib::SignalProxy1< bool, GdkEventGrabBroken* > | signal_grab_broken_event ()
Glib::SignalProxy0<void> | signal_grab_focus ()
Glib::SignalProxy1<void, bool> | signal_grab_notify ()
Glib::SignalProxy0<void> | signal_hide ()
Glib::SignalProxy1< void, Widget* > | signal_hierarchy_changed ()
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_press_event ()
Glib::SignalProxy1< bool, GdkEventKey* > | signal_key_release_event ()
Glib::SignalProxy1< bool, GdkEventCrossing* > | signal_leave_notify_event ()
Glib::SignalProxy0<void> | signal_map ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_map_event ()
Glib::SignalProxy1<bool, bool> | signal_mnemonic_activate ()
Glib::SignalProxy1< bool, GdkEventMotion* > | signal_motion_notify_event ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_no_expose_event ()
Glib::SignalProxy1< void, Widget* > | signal_parent_changed ()
Glib::SignalProxy0<bool> | signal_popup_menu ()
Glib::SignalProxy1< bool, GdkEventProperty* > | signal_property_notify_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_in_event ()
Glib::SignalProxy1< bool, GdkEventProximity* > | signal_proximity_out_event ()
Glib::SignalProxy4< bool, int, int, bool, const Glib::RefPtr <Tooltip >&> | signal_query_tooltip ()
Glib::SignalProxy0<void> | signal_realize ()
Glib::SignalProxy1< void, const Glib::RefPtr <Gdk::Screen >&> | signal_screen_changed ()
Glib::SignalProxy1< bool, GdkEventScroll* > | signal_scroll_event ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_clear_event ()
Glib::SignalProxy3< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_notify_event ()
Glib::SignalProxy2< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy1< bool, GdkEventSelection* > | signal_selection_request_event ()
Glib::SignalProxy0<void> | signal_show ()
Glib::SignalProxy1< void, Allocation& > | signal_size_allocate ()
Glib::SignalProxy1< void, Requisition* > | signal_size_request ()
Glib::SignalProxy1< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy1< void, const Glib::RefPtr<Gtk::Style >&> | signal_style_changed ()
| The style-set signal is emitted when a new style has been set on a widget.
Glib::SignalProxy0<void> | signal_unmap ()
Glib::SignalProxy1< bool, GdkEventAny* > | signal_unmap_event ()
Glib::SignalProxy0<void> | signal_unrealize ()
Glib::SignalProxy1< bool, GdkEventVisibility* > | signal_visibility_notify_event ()
Glib::SignalProxy1< bool, GdkEventWindowState* > | signal_window_state_event ()
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.
void | size_request (const Requisition& requisition)
| This function is typically used when implementing a Gtk::Container subclass.
Requisition | size_request () const
| This function is typically used when implementing a Gtk::Container subclass.
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify().
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | unmap ()
| This function is only for use in widget implementations.
void | unparent ()
| This function is only for use in widget implementations.
void | unset_base (StateType state)
| Undo the effect of previous calls to modify_base() for a particular state.
void | unset_bg (StateType state)
| Undo the effect of previous calls to modify_bg() for a particular state.
void | unset_composite_name ()
void | unset_cursor ()
| See modify_cursor().
void | unset_fg (StateType state)
| Undo the effect of previous calls to modify_fg() for a particular state.
void | unset_flags (WidgetFlags flags)
void | unset_font ()
| Undo the effect of previous calls to modify_font() for a particular state.
void | unset_input_shape_combine_mask ()
void | unset_name ()
void | unset_shape_combine_mask ()
void | unset_style ()
void | unset_text (StateType state)
| Undo the effect of previous calls to modify_text() for a particular state.
virtual | ~Widget ()

## Static Public Member Functions

static Widget* | drag_get_source_widget (const Glib::RefPtr<Gdk::DragContext>& context)
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events.
static Glib::RefPtr <Gdk::Colormap> | get_default_colormap ()
| Obtains the default colormap used to create widgets.
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
static Glib::RefPtr<Style> | get_default_style ()
| Returns: the default style.
static Glib::RefPtr<Gdk::Visual> | get_default_visual ()
| Obtains the visual of the default colormap.
static void | pop_colormap ()
| Removes a colormap pushed with push_colormap().
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child().
static void | push_colormap (const Glib::RefPtr<const Gdk::Colormap>& cmap)
| Pushes cmap onto a global stack of colormaps; the topmost colormap on the stack will be used to create all widgets.
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call.
static void | set_default_colormap (const Glib::RefPtr<const Gdk::Colormap>& colormap)
| Sets the default colormap to use when creating widgets.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction().

## Protected Member Functions

virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual Glib::RefPtr<Atk::Object> | get_accessible_vfunc ()
void | get_child_requisition (Requisition& requisition) const
| This function is only for use in widget implementations.
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget.
virtual void | hide_all_vfunc ()
virtual bool | on_button_press_event (GdkEventButton* event)
virtual bool | on_button_release_event (GdkEventButton* event)
virtual void | on_child_notify (GParamSpec* pspec)
virtual bool | on_client_event (GdkEventClient* event)
virtual bool | on_configure_event (GdkEventConfigure* event)
virtual bool | on_delete_event (GdkEventAny* event)
virtual void | on_direction_changed (TextDirection direction)
virtual void | on_drag_begin (const Glib::RefPtr<Gdk::DragContext>& context)
virtual void | on_drag_data_delete (const Glib::RefPtr<Gdk::DragContext>& context)
virtual void | on_drag_data_get (const Glib::RefPtr<Gdk::DragContext>& context, SelectionData& selection_data, guint info, guint time)
virtual void | on_drag_data_received (const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
virtual bool | on_drag_drop (const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, guint time)
virtual void | on_drag_end (const Glib::RefPtr<Gdk::DragContext>& context)
virtual void | on_drag_leave (const Glib::RefPtr<Gdk::DragContext>& context, guint time)
virtual bool | on_drag_motion (const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, guint time)
virtual bool | on_enter_notify_event (GdkEventCrossing* event)
virtual bool | on_event (GdkEvent* event)
virtual bool | on_expose_event (GdkEventExpose* event)
virtual bool | on_focus (DirectionType direction)
virtual bool | on_focus_in_event (GdkEventFocus* event)
virtual bool | on_focus_out_event (GdkEventFocus* event)
virtual Glib::RefPtr<Atk::Object> | on_get_accessible ()
virtual void | on_grab_focus ()
virtual void | on_grab_notify (bool was_grabbed)
virtual void | on_hide ()
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
virtual bool | on_key_press_event (GdkEventKey* event)
virtual bool | on_key_release_event (GdkEventKey* event)
virtual bool | on_leave_notify_event (GdkEventCrossing* event)
virtual void | on_map ()
virtual bool | on_map_event (GdkEventAny* event)
virtual bool | on_mnemonic_activate (bool group_cycling)
virtual bool | on_motion_notify_event (GdkEventMotion* event)
virtual bool | on_no_expose_event (GdkEventAny* event)
virtual void | on_parent_changed (Widget* previous_parent)
virtual bool | on_property_notify_event (GdkEventProperty* event)
virtual bool | on_proximity_in_event (GdkEventProximity* event)
virtual bool | on_proximity_out_event (GdkEventProximity* event)
virtual void | on_realize ()
virtual void | on_screen_changed (const Glib::RefPtr<Gdk::Screen>& previous_screen)
virtual bool | on_scroll_event (GdkEventScroll* event)
virtual bool | on_selection_clear_event (GdkEventSelection* event)
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
virtual bool | on_selection_notify_event (GdkEventSelection* event)
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
virtual bool | on_selection_request_event (GdkEventSelection* event)
virtual void | on_show ()
virtual void | on_size_allocate (Allocation& allocation)
virtual void | on_size_request (Requisition* requisition)
virtual void | on_state_changed (Gtk::StateType previous_state)
virtual void | on_style_changed (const Glib::RefPtr<Gtk::Style>& previous_style)
virtual void | on_unmap ()
virtual bool | on_unmap_event (GdkEventAny* event)
virtual void | on_unrealize ()
virtual bool | on_visibility_notify_event (GdkEventVisibility* event)
virtual bool | on_window_state_event (GdkEventWindowState* event)
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget.
void | realize_if_needed ()
void | set_allocation (const Allocation& value)
void | set_window (const Glib::RefPtr<Gdk::Window>& value)
virtual void | show_all_vfunc ()
void | unrealize ()
| This function is only useful in widget implementations.
| Widget ()

## Friends

class | Main

## Related Functions

(Note that these are not member functions.)
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Constructor & Destructor Documentation

virtual Gtk::Widget::~Widget | ( |  | ) | `[virtual]`

Gtk::Widget::Widget | ( |  | ) | `[protected]`

## Member Function Documentation

bool Gtk::Widget::activate | ( |  | ) |

For widgets that can be "activated" (buttons, menu items, etc.

) this function activates them. Activation is what happens when you press Enter on a widget during key navigation. If widget isn't activatable, the function returns `false`.

Returns:
  `true` if the widget was activatable.

Reimplemented in Gtk::MenuItem.

void Gtk::Widget::add_accelerator | ( | const Glib::ustring & | accel_signal,
|  | const Glib::RefPtr<AccelGroup>& | accel_group,
|  | guint | accel_key,
|  | Gdk::ModifierType | accel_mods,
|  | AccelFlags | accel_flags |
| ) |  |  |

Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated.

The accel_group needs to be added to the widget's toplevel via Gtk::Window::add_accel_group(), and the signal must be of type RUN_ACTION. Accelerators added through this function are not user changeable during runtime. If you want to support accelerators that can be changed by the user, use gtk_accel_map_add_entry() and set_accel_path() or Gtk::MenuItem::set_accel_path() instead.

Parameters:

  | accel_signal | Widget signal to emit on accelerator activation.
  | accel_group | Accel group for this widget, added to its toplevel.
  | accel_key | GDK keyval of the accelerator.
  | accel_mods | Modifier key combination of the accelerator.
  | accel_flags | Flag accelerators, e.g. Gtk::ACCEL_VISIBLE.

void Gtk::Widget::add_events | ( | Gdk::EventMask | events | ) |

Adds the events in the bitfield events to the event mask for widget.

See set_events() for details.

Parameters:

  | events | An event mask, see Gdk::EventMask.

void Gtk::Widget::add_mnemonic_label | ( | Widget& | label | ) |

Adds a widget to the list of mnemonic labels for this widget.

(See list_mnemonic_labels()). Note the list of mnemonic labels for the widget is cleared when the widget is destroyed, so the caller must make sure to update its internal state at this point as well.

Since gtkmm 2.4:

Parameters:

  | label | A Gtk::Widget that acts as a mnemonic label for widget.

void Gtk::Widget::add_modal_grab | ( |  | ) |

Block events to everything else than this widget and its children.

This way you can get modal behaviour (usually not recommended). One practical example could be when implementing a key-binding widget that needs exclusive access to the key combination that the user presses next.

Calls to add_modal_grab should be paired with calls to remove_modal_grab.

bool Gtk::Widget::app_paintable | ( |  | ) | const

bool Gtk::Widget::can_default | ( |  | ) | const

bool Gtk::Widget::can_focus | ( |  | ) | const

bool Gtk::Widget::child_focus | ( | DirectionType | direction | ) |

This function is used by custom widget implementations; if you're writing an app, you'd use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order.

So you may want to investigate those functions instead.

child_focus() is called by containers as the user moves around the window using keyboard shortcuts. direction indicates what kind of motion is taking place (up, down, left, right, tab forward, tab backward). child_focus() emits the Gtk::Widget::focus" signal; widgets override the default handler for this signal in order to implement appropriate focus behavior.

The default focus handler for a widget should return `true` if moving in direction left the focus on a focusable location inside that widget, and `false` if moving in direction moved the focus outside the widget. If returning `true`, widgets normally call grab_focus() to place the focus accordingly; if returning `false`, they don't modify the current focus location.

This function replaces gtk_container_focus() from GTK+ 1.2. It was necessary to check that the child was visible, sensitive, and focusable before calling gtk_container_focus(). child_focus() returns `false` if the widget is not currently in a focusable state, so there's no need for those checks.

Parameters:

  | direction | Direction of focus movement.

Returns:
  `true` if focus ended up inside widget.

void Gtk::Widget::child_notify | ( | const Glib::ustring & | child_property | ) |

Emits a Gtk::Widget::child-notify signal for the child property child_property on widget.

This is the analogue of Glib::object_notify() for child properties.

Parameters:

  | child_property | The name of a child property installed on the class of widget<!-- -->'s parent.

void Gtk::Widget::class_path | ( | Glib::ustring & | path,
|  | Glib::ustring & | path_reversed |
| ) |  |  |

Glib::RefPtr<Pango::Context> Gtk::Widget::create_pango_context | ( |  | ) |

Creates a new Pango::Context with the appropriate font map, font description, and base direction for drawing text for this widget.

See also get_pango_context().

Returns:
  The new Pango::Context.

Glib::RefPtr<Pango::Layout> Gtk::Widget::create_pango_layout | ( | const Glib::ustring & | text | ) |

Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget.

If you keep a Pango::Layout created in this way around, in order to notify the layout of changes to the base direction or font of this widget, you must call pango_layout_context_changed() in response to the Gtk::Widget::style-set and Gtk::Widget::direction-changed signals for the widget.

Parameters:

  | text | Text to set on the layout (can be `0`).

Returns:
  The new Pango::Layout.

virtual void Gtk::Widget::dispatch_child_properties_changed_vfunc | ( | guint | p1,
|  | GParamSpec ** | p2 |
| ) |  |  | `[protected, virtual]`

bool Gtk::Widget::double_buffered | ( |  | ) | const

Glib::RefPtr<Gdk::DragContext> Gtk::Widget::drag_begin | ( | const Glib::RefPtr<TargetList>& | targets,
|  | Gdk::DragAction | actions,
|  | int | button,
|  | GdkEvent * | event |
| ) |  |  |

Initiates a drag on the source side.

The function only needs to be used when the application is starting drags itself, and is not needed when gtk_drag_source_set() is used.

Parameters:

  | targets | The targets (data formats) in which the source can provide the data.
  | actions | A bitmask of the allowed drag actions for this drag.
  | button | The button the user clicked to start the drag.
  | event | The event that triggered the start of the drag.

Returns:
  The context for this drag.

bool Gtk::Widget::drag_check_threshold | ( | int | start_x,
|  | int | start_y,
|  | int | current_x,
|  | int | current_y |
| ) |  |  |

Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK+ drag threshold, and thus should trigger the beginning of a drag-and-drop operation.

Parameters:

  | start_x | X coordinate of start of drag.
  | start_y | Y coordinate of start of drag.
  | current_x | Current X coordinate.
  | current_y | Current Y coordinate.

Returns:
  `true` if the drag threshold has been passed.

void Gtk::Widget::drag_dest_add_image_targets | ( |  | ) |

Add the image targets supported by Gtk::Selection to the target list of the drag destination.

The targets are added with info = 0. If you need another value, use gtk_target_list_add_image_targets() and gtk_drag_dest_set_target_list().

Since gtkmm 2.6:

Parameters:

  | widget | A Gtk::Widget that's a drag destination.

void Gtk::Widget::drag_dest_add_text_targets | ( |  | ) |

Add the text targets supported by Gtk::Selection to the target list of the drag destination.

The targets are added with info = 0. If you need another value, use gtk_target_list_add_text_targets() and gtk_drag_dest_set_target_list().

Since gtkmm 2.6:

Parameters:

  | widget | A Gtk::Widget that's a drag destination.

void Gtk::Widget::drag_dest_add_uri_targets | ( |  | ) |

Add the URI targets supported by Gtk::Selection to the target list of the drag destination.

The targets are added with info = 0. If you need another value, use gtk_target_list_add_uri_targets() and gtk_drag_dest_set_target_list().

Since gtkmm 2.6:

Parameters:

  | widget | A Gtk::Widget that's a drag destination.

Glib::ustring Gtk::Widget::drag_dest_find_target | ( | const Glib::RefPtr<Gdk::DragContext>& | context | ) | const

Glib::ustring Gtk::Widget::drag_dest_find_target | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | const Glib::RefPtr<TargetList>& | target_list |
| ) |  |  | const

Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning Gdk::NONE.

dest_target_list should usually be the return value from gtk_drag_dest_get_target_list(), but some widgets may have different valid targets for different parts of the widget; in that case, they will have to implement a drag_motion handler that passes the correct target list to this function.

Parameters:

  | context | Drag context.
  | target_list | List of droppable targets.

Returns:
  First target that the source offers and the dest can accept, or Gdk::NONE.

Glib::RefPtr<const TargetList> Gtk::Widget::drag_dest_get_target_list | ( |  | ) | const

Return value: the Gtk::TargetList, or `0` if none.

Returns:
  The Gtk::TargetList, or `0` if none.

Glib::RefPtr<TargetList> Gtk::Widget::drag_dest_get_target_list | ( |  | ) |

Return value: the Gtk::TargetList, or `0` if none.

Returns:
  The Gtk::TargetList, or `0` if none.

void Gtk::Widget::drag_dest_set | ( | const ArrayHandle_TargetEntry & | targets,
|  | DestDefaults | flags = `DEST_DEFAULT_ALL`,
|  | Gdk::DragAction | actions = `Gdk::ACTION_COPY` |
| ) |  |  |

void Gtk::Widget::drag_dest_set | ( | DestDefaults | flags = `DestDefaults(0)`,
|  | Gdk::DragAction | actions = `Gdk::DragAction(0)` |
| ) |  |  |

void Gtk::Widget::drag_dest_set_proxy | ( | const Glib::RefPtr<Gdk::Window>& | proxy_window,
|  | Gdk::DragProtocol | protocol,
|  | bool | use_coordinates |
| ) |  |  |

void Gtk::Widget::drag_dest_set_target_list | ( | const Glib::RefPtr<TargetList>& | target_list | ) |

Sets the target types that this widget can accept from drag-and-drop.

The widget must first be made into a drag destination with gtk_drag_dest_set().

Parameters:

  | target_list | List of droppable targets, or `0` for none.

void Gtk::Widget::drag_dest_unset | ( |  | ) |

void Gtk::Widget::drag_get_data | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | const Glib::ustring & | target,
|  | guint32 | time |
| ) |  |  |

void Gtk::Widget::drag_get_data | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | Glib::ustring & | target,
|  | guint32 | time |
| ) |  |  |

static Widget* Gtk::Widget::drag_get_source_widget | ( | const Glib::RefPtr<Gdk::DragContext>& | context | ) | `[static]`

void Gtk::Widget::drag_highlight | ( |  | ) |

void Gtk::Widget::drag_set_as_icon | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | int | hot_x,
|  | int | hot_y |
| ) |  |  |

void Gtk::Widget::drag_source_add_image_targets | ( |  | ) |

Add the writable image targets supported by Gtk::Selection to the target list of the drag source.

The targets are added with info = 0. If you need another value, use gtk_target_list_add_image_targets() and gtk_drag_source_set_target_list().

Since gtkmm 2.6:

Parameters:

  | widget | A Gtk::Widget that's is a drag source.

void Gtk::Widget::drag_source_add_text_targets | ( |  | ) |

Add the text targets supported by Gtk::Selection to the target list of the drag source.

The targets are added with info = 0. If you need another value, use gtk_target_list_add_text_targets() and gtk_drag_source_set_target_list().

Since gtkmm 2.6:

Parameters:

  | widget | A Gtk::Widget that's is a drag source.

void Gtk::Widget::drag_source_add_uri_targets | ( |  | ) |

Add the URI targets supported by Gtk::Selection to the target list of the drag source.

The targets are added with info = 0. If you need another value, use gtk_target_list_add_uri_targets() and gtk_drag_source_set_target_list().

Since gtkmm 2.6:

Parameters:

  | widget | A Gtk::Widget that's is a drag source.

void Gtk::Widget::drag_source_set | ( | const ArrayHandle_TargetEntry & | targets,
|  | Gdk::ModifierType | start_button_mask = `Gdk::MODIFIER_MASK`,
|  | Gdk::DragAction | actions = `Gdk::ACTION_COPY` |
| ) |  |  |

void Gtk::Widget::drag_source_set_icon | ( | const Glib::ustring & | icon_name | ) |

Sets the icon that will be used for drags from a particular source to a themed icon.

See the docs for Gtk::IconTheme for more details.

Since gtkmm 2.8:

Parameters:

  | widget | A Gtk::Widget.
  | icon_name | Name of icon to use.

void Gtk::Widget::drag_source_set_icon | ( | const StockID& | stock_id | ) |

Sets the icon that will be used for drags from a particular source to a stock icon.

Parameters:

  | stock_id | The ID of the stock icon to use.

void Gtk::Widget::drag_source_set_icon | ( | const Glib::RefPtr<Gdk::Pixbuf>& | pixbuf | ) |

Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf.

GTK+ retains a reference for pixbuf and will release it when it is no longer needed.

Parameters:

  | pixbuf | The Gdk::Pixbuf for the drag icon.

void Gtk::Widget::drag_source_set_icon | ( | const Glib::RefPtr<Gdk::Colormap>& | colormap,
|  | const Glib::RefPtr<Gdk::Pixmap>& | pixmap,
|  | const Glib::RefPtr<Gdk::Bitmap>& | mask |
| ) |  |  |

Sets the icon that will be used for drags from a particular widget from a pixmap/mask.

GTK+ retains references for the arguments, and will release them when they are no longer needed. Use gtk_drag_source_set_icon_pixbuf() instead.

Parameters:

  | colormap | The colormap of the icon.
  | pixmap | The image data for the icon.
  | mask | The transparency mask for an image.

void Gtk::Widget::drag_source_unset | ( |  | ) |

void Gtk::Widget::drag_unhighlight | ( |  | ) |

void Gtk::Widget::draw_insertion_cursor | ( | Glib::RefPtr<Gdk::Drawable> | drawable,
|  | const Gdk::Rectangle& | area,
|  | const Gdk::Rectangle& | location,
|  | bool | is_primary,
|  | TextDirection | direction,
|  | bool | draw_arrow = `true` |
| ) |  |  |

void Gtk::Widget::ensure_style | ( |  | ) |

Ensures that widget has a style ( widget->style).

Not a very useful function; most of the time, if you want the style, the widget is realized, and realized widgets are guaranteed to have a style already.

void Gtk::Widget::error_bell | ( |  | ) |

Notifies the user about an input-related error on this widget.

If the Gtk::Settings gtk-error-bell proeprty is true, it calls Gdk::Window::beep(), otherwise it does nothing.

Note that the effect of Gdk::Window::beep() can be configured in many ways, depending on the windowing backend and the desktop environment or window manager that is used.

Since gtkmm 2.12:

bool Gtk::Widget::event | ( | GdkEvent * | event | ) |

Rarely-used function.

This function is used to emit the event signals on a widget (those signals should never be emitted without using this function to do so). If you want to synthesize an event though, don't use this function; instead, use gtk_main_do_event() so the event will behave as if it were in the event queue. Don't synthesize expose events; instead, use gdk_window_invalidate_rect() to invalidate a region of the window.

Parameters:

  | event | A Gdk::Event.

Returns:
  Return from the event signal emission (`true` if the event was handled).

void Gtk::Widget::freeze_child_notify | ( |  | ) |

Stops emission of Gtk::Widget::child-notify signals on widget.

The signals are queued until thaw_child_notify() is called on widget.

This is the analogue of Glib::object_freeze_notify() for child properties.

Glib::RefPtr<Atk::Object> Gtk::Widget::get_accessible | ( |  | ) |

Returns: the Atk::Object associated with widget.

Returns:
  The Atk::Object associated with widget.

virtual Glib::RefPtr<Atk::Object> Gtk::Widget::get_accessible_vfunc | ( |  | ) | `[protected, virtual]`

Glib::RefPtr<const Action> Gtk::Widget::get_action | ( |  | ) | const

Returns: the action that a widget is a proxy for, or.

Returns:
  The action that a widget is a proxy for, or `0`, if it is not attached to an action.

Since gtkmm 2.10:

Glib::RefPtr<Action> Gtk::Widget::get_action | ( |  | ) |

Returns: the action that a widget is a proxy for, or.

Returns:
  The action that a widget is a proxy for, or `0`, if it is not attached to an action.

Since gtkmm 2.10:

Allocation Gtk::Widget::get_allocation | ( |  | ) | const

const Widget* Gtk::Widget::get_ancestor | ( | GType | widget_type | ) | const

Gets the first ancestor of widget with type widget_type.

For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first Gtk::Box that's an ancestor of widget. No reference will be added to the returned widget; it should not be unreferenced. See note about checking for a toplevel Gtk::Window in the docs for get_toplevel().

Note that unlike is_ancestor(), get_ancestor() considers widget to be an ancestor of itself.

Parameters:

  | widget_type | Ancestor type.

Returns:
  The ancestor widget, or `0` if not found.

Widget* Gtk::Widget::get_ancestor | ( | GType | widget_type | ) |

Gets the first ancestor of widget with type widget_type.

For example, `gtk_widget_get_ancestor (widget, GTK_TYPE_BOX)` gets the first Gtk::Box that's an ancestor of widget. No reference will be added to the returned widget; it should not be unreferenced. See note about checking for a toplevel Gtk::Window in the docs for get_toplevel().

Note that unlike is_ancestor(), get_ancestor() considers widget to be an ancestor of itself.

Parameters:

  | widget_type | Ancestor type.

Returns:
  The ancestor widget, or `0` if not found.

void Gtk::Widget::get_child_requisition | ( | Requisition& | requisition | ) | const`[protected]`

This function is only for use in widget implementations.

Obtains widget->requisition, unless someone has forced a particular geometry on the widget (e.g. with set_usize()), in which case it returns that geometry instead of the widget's requisition.

This function differs from size_request() in that it retrieves the last size request value from widget->requisition, while size_request() actually calls the "size_request" method on widget to compute the size request and fill in widget->requisition, and only then returns widget->requisition.

Because this function does not call the "size_request" method, it can only be used when you know that widget->requisition is up-to-date, that is, size_request() has been called since the last time a resize was queued. In general, only container implementations have this information; applications should use size_request().

Parameters:

  | requisition | A Gtk::Requisition to be filled in.

bool Gtk::Widget::get_child_visible | ( |  | ) | const

Gets the value set with set_child_visible().

If you feel a need to use this function, your code probably needs reorganization.

This function is only useful for container implementations and never should be called by an application.

Returns:
  `true` if the widget is mapped with the parent.

Glib::RefPtr<const Clipboard> Gtk::Widget::get_clipboard | ( | const Glib::ustring & | selection | ) | const

Return value: the appropriate clipboard object.

If no

Parameters:

  | selection | A Gdk::Atom which identifies the clipboard to use. Gdk::SELECTION_CLIPBOARD gives the default clipboard. Another common value is Gdk::SELECTION_PRIMARY, which gives the primary X selection.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time.

Since gtkmm 2.2:

Glib::RefPtr<Clipboard> Gtk::Widget::get_clipboard | ( | const Glib::ustring & | selection | ) |

Return value: the appropriate clipboard object.

If no

Parameters:

  | selection | A Gdk::Atom which identifies the clipboard to use. Gdk::SELECTION_CLIPBOARD gives the default clipboard. Another common value is Gdk::SELECTION_PRIMARY, which gives the primary X selection.

Returns:
  The appropriate clipboard object. If no clipboard already exists, a new one will be created. Once a clipboard object has been created, it is persistent for all time.

Since gtkmm 2.2:

Glib::RefPtr<Gdk::Colormap> Gtk::Widget::get_colormap | ( |  | ) |

Gets the colormap that will be used to render widget.

No reference will be added to the returned colormap; it should not be unreferenced.

Returns:
  The colormap used by widget.

Glib::ustring Gtk::Widget::get_composite_name | ( |  | ) | const

Obtains the composite name of a widget.

Returns:
  The composite name of widget, or `0` if widget is not a composite child. The string should not be freed when it is no longer needed.

static Widget* Gtk::Widget::get_current_modal_grab | ( |  | ) | `[static]`

Retrieve the widget which is currently grabbing all events.

static Glib::RefPtr<Gdk::Colormap> Gtk::Widget::get_default_colormap | ( |  | ) | `[static]`

Obtains the default colormap used to create widgets.

Returns:
  Default widget colormap.

static TextDirection Gtk::Widget::get_default_direction | ( |  | ) | `[static]`

Obtains the current default reading direction.

See set_default_direction().

Returns:
  The current default direction.

static Glib::RefPtr<Style> Gtk::Widget::get_default_style | ( |  | ) | `[static]`

Returns: the default style.

This Gtk::Style object is owned

Returns:
  The default style. This Gtk::Style object is owned by GTK+ and should not be modified or freed.

static Glib::RefPtr<Gdk::Visual> Gtk::Widget::get_default_visual | ( |  | ) | `[static]`

Obtains the visual of the default colormap.

Not really useful; used to be useful before gdk_colormap_get_visual() existed.

Returns:
  Visual of the default colormap.

TextDirection Gtk::Widget::get_direction | ( |  | ) | const

Gets the reading direction for a particular widget.

See set_direction().

Returns:
  The reading direction for the widget.

TextDirection Gtk::Widget::get_direction | ( |  | ) |

Gets the reading direction for a particular widget.

See set_direction().

Deprecated:
  Use the const version of this method.

Returns:
  The reading direction for the widget.

Glib::RefPtr<const Gdk::Display> Gtk::Widget::get_display | ( |  | ) | const

Get the Gdk::Display for the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns:
  The Gdk::Display for the toplevel for this widget.

Since gtkmm 2.2:

Glib::RefPtr<Gdk::Display> Gtk::Widget::get_display | ( |  | ) |

Get the Gdk::Display for the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns:
  The Gdk::Display for the toplevel for this widget.

Since gtkmm 2.2:

Gdk::EventMask Gtk::Widget::get_events | ( |  | ) | const

Return value: event mask for widget.

Returns:
  Event mask for widget.

Gdk::ExtensionMode Gtk::Widget::get_extension_events | ( |  | ) | const

Retrieves the extension events the widget will receive; see gdk_input_set_extension_events().

Returns:
  Extension events for widget.

WidgetFlags Gtk::Widget::get_flags | ( |  | ) | const

bool Gtk::Widget::get_has_tooltip | ( |  | ) | const

Return value: current value of has-tooltip on widget.

Returns:
  Current value of has-tooltip on widget.

Since gtkmm 2.12:

int Gtk::Widget::get_height | ( |  | ) | const

Glib::RefPtr<const RcStyle> Gtk::Widget::get_modifier_style | ( |  | ) | const

Return value: the modifier style for the widget.

This rc style is

Returns:
  The modifier style for the widget. This rc style is owned by the widget. If you want to keep a pointer to value this around, you must add a refcount using Glib::object_ref().

Glib::RefPtr<RcStyle> Gtk::Widget::get_modifier_style | ( |  | ) |

Return value: the modifier style for the widget.

This rc style is

Returns:
  The modifier style for the widget. This rc style is owned by the widget. If you want to keep a pointer to value this around, you must add a refcount using Glib::object_ref().

Glib::ustring Gtk::Widget::get_name | ( |  | ) | const

Retrieves the name of a widget.

See set_name() for the significance of widget names.

Returns:
  Name of the widget. This string is owned by GTK+ and should not be modified or freed.

Reimplemented in Gtk::AboutDialog.

bool Gtk::Widget::get_no_show_all | ( |  | ) | const

Return value: the current value of the "no-show-all" property.

Returns:
  The current value of the "no-show-all" property.

Since gtkmm 2.4:

Glib::RefPtr<Pango::Context> Gtk::Widget::get_pango_context | ( |  | ) |

Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget.

Unlike the context returned by create_pango_context(), this context is owned by the widget (it can be used until the screen for the widget changes or the widget is removed from its toplevel), and will be updated to match any changes to the widget's attributes.

If you create and keep a Pango::Layout using this context, you must deal with changes to the context by calling pango_layout_context_changed() on the layout in response to the Gtk::Widget::style-set and Gtk::Widget::direction-changed signals for the widget.

Returns:
  The Pango::Context for the widget.

const Container* Gtk::Widget::get_parent | ( |  | ) | const

Return value: the parent container of widget, or `0`.

Returns:
  The parent container of widget, or `0`.

Container* Gtk::Widget::get_parent | ( |  | ) |

Return value: the parent container of widget, or `0`.

Returns:
  The parent container of widget, or `0`.

Glib::RefPtr<const Gdk::Window> Gtk::Widget::get_parent_window | ( |  | ) | const

Gets widget's parent window.

Returns:
  The parent window of widget.

Glib::RefPtr<Gdk::Window> Gtk::Widget::get_parent_window | ( |  | ) |

Gets widget's parent window.

Returns:
  The parent window of widget.

void Gtk::Widget::get_pointer | ( | int & | x,
|  | int & | y |
| ) |  |  | const

Obtains the location of the mouse pointer in widget coordinates.

Widget coordinates are a bit odd; for historical reasons, they are defined as widget->window coordinates for widgets that are not Gtk::NO_WINDOW widgets, and are relative to widget->allocation.x, widget->allocation.y for widgets that are Gtk::NO_WINDOW widgets.

Parameters:

  | x | Return location for the X coordinate, or `0`.
  | y | Return location for the Y coordinate, or `0`.

Requisition Gtk::Widget::get_requisition | ( |  | ) | const

Glib::RefPtr<const Gdk::Window> Gtk::Widget::get_root_window | ( |  | ) | const

Get the root window where this widget is located.

This function can only be called after the widget has been added to a widget heirarchy with Gtk::Window at the top.

The root window is useful for such purposes as creating a popup Gdk::Window associated with the window. In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns:
  The Gdk::Window root window for the toplevel for this widget.

Since gtkmm 2.2:

Glib::RefPtr<Gdk::Window> Gtk::Widget::get_root_window | ( |  | ) |

Get the root window where this widget is located.

This function can only be called after the widget has been added to a widget heirarchy with Gtk::Window at the top.

The root window is useful for such purposes as creating a popup Gdk::Window associated with the window. In general, you should only create display specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns:
  The Gdk::Window root window for the toplevel for this widget.

Since gtkmm 2.2:

Gtk::StateType Gtk::Widget::get_saved_state | ( |  | ) | const

Glib::RefPtr<const Gdk::Screen> Gtk::Widget::get_screen | ( |  | ) | const

Get the Gdk::Screen from the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create screen specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns:
  The Gdk::Screen for the toplevel for this widget.

Since gtkmm 2.2:

Reimplemented in Gtk::Invisible, and Gtk::Window.

Glib::RefPtr<Gdk::Screen> Gtk::Widget::get_screen | ( |  | ) |

Get the Gdk::Screen from the toplevel window associated with this widget.

This function can only be called after the widget has been added to a widget hierarchy with a Gtk::Window at the top.

In general, you should only create screen specific resources when a widget has been realized, and you should free those resources when the widget is unrealized.

Returns:
  The Gdk::Screen for the toplevel for this widget.

Since gtkmm 2.2:

Reimplemented in Gtk::Invisible, and Gtk::Window.

Glib::RefPtr<Settings> Gtk::Widget::get_settings | ( |  | ) |

Gets the settings object holding the settings (global property settings, RC file information, etc) used for this widget.

Note that this function can only be called when the Gtk::Widget is attached to a toplevel, since the settings object is specific to a particular Gdk::Screen.

Returns:
  The relevant Gtk::Settings object.

Reimplemented in Gtk::PrintUnixDialog.

void Gtk::Widget::get_size_request | ( | int & | width,
|  | int & | height |
| ) |  |  | const

Gets the size request that was explicitly set for the widget using set_size_request().

A value of -1 stored in width or height indicates that that dimension has not been set explicitly and the natural requisition of the widget will be used intead. See set_size_request(). To get the size a widget will actually use, call size_request() instead of this function.

Parameters:

  | width | Return location for width, or `0`.
  | height | Return location for height, or `0`.

Glib::RefPtr<Gdk::Pixmap> Gtk::Widget::get_snapshot | ( |  | ) | const

Create a Gdk::Pixmap of the contents of the widget and its children.

Works even if the widget is obscured. The depth and visual of the resulting pixmap is dependent on the widget being snapshot and likely differs from those of a target widget displaying the pixmap. The function Gdk::Pixbuf::get_from_drawable() can be used to convert the pixmap to a visual independant representation.

The snapshot area used by this function is the widget's allocation plus any extra space occupied by additional windows belonging to this widget (such as the arrows of a spin button). Thus, the resulting snapshot pixmap is possibly larger than the allocation.

The returned pixmap can be empty.

Returns:
  A Gdk::Pixmap snapshot of the widget

Since gtkmm 2.14:

Glib::RefPtr<Gdk::Pixmap> Gtk::Widget::get_snapshot | ( | Gdk::Rectangle& | clip_rect | ) | const

Gtk::StateType Gtk::Widget::get_state | ( |  | ) | const

Glib::RefPtr<const Style> Gtk::Widget::get_style | ( |  | ) | const

Simply an accessor function that returns widget->style.

Returns:
  The widget's Gtk::Style.

Glib::RefPtr<Style> Gtk::Widget::get_style | ( |  | ) |

Simply an accessor function that returns widget->style.

Returns:
  The widget's Gtk::Style.

template <class PropertyType>

void Gtk::Widget::get_style_property | ( | const Glib::ustring & | the_property_name,
|  | PropertyType & | value |
| ) |  |  | const`[inline]`

void Gtk::Widget::get_style_property_value | ( | const Glib::ustring & | the_property_name,
|  | Glib::ValueBase & | value |
| ) |  |  | const`[protected]`

Gets the value of a style property of widget.

Parameters:

  | the_property_name | The name of a style property.
  | value | Location to return the property value.

Glib::ustring Gtk::Widget::get_tooltip_markup | ( |  | ) | const

Gets the contents of the tooltip for widget.

Returns:
  The tooltip text.

Since gtkmm 2.12:

Glib::ustring Gtk::Widget::get_tooltip_text | ( |  | ) | const

Gets the contents of the tooltip for widget.

Returns:
  The tooltip text.

Since gtkmm 2.12:

Window* Gtk::Widget::get_tooltip_window | ( |  | ) |

Return value: The Gtk::Window of the current tooltip.

Returns:
  The Gtk::Window of the current tooltip.

Since gtkmm 2.12:

const Container* Gtk::Widget::get_toplevel | ( |  | ) | const

This function returns the topmost widget in the container hierarchy widget is a part of.

If widget has no parent widgets, it will be returned as the topmost widget. No reference will be added to the returned widget; it should not be unreferenced.

Note the difference in behavior vs. get_ancestor(); `gtk_widget_get_ancestor (widget, GTK_TYPE_WINDOW)` would return `0` if widget wasn't inside a toplevel window, and if the window was inside a Gtk::Window-derived widget which was in turn inside the toplevel Gtk::Window. While the second case may seem unlikely, it actually happens when a Gtk::Plug is embedded inside a Gtk::Socket within the same application.

To reliably find the toplevel Gtk::Window, use get_toplevel() and check if the T::OPLEVEL flags is set on the result.

     GtkWidget* toplevel = gtk_widget_get_toplevel (widget);
     if (GTK_WIDGET_TOPLEVEL (toplevel))
     {
     [ Perform action on toplevel. ]
     }

Returns:
  The topmost ancestor of widget, or widget itself if there's no ancestor.

Container* Gtk::Widget::get_toplevel | ( |  | ) |

This function returns the topmost widget in the container hierarchy widget is a part of.

If widget has no parent widgets, it will be returned as the topmost widget. No reference will be added to the returned widget; it should not be unreferenced.

Note the difference in behavior vs. get_ancestor(); `gtk_widget_get_ancestor (widget, GTK_TYPE_WINDOW)` would return `0` if widget wasn't inside a toplevel window, and if the window was inside a Gtk::Window-derived widget which was in turn inside the toplevel Gtk::Window. While the second case may seem unlikely, it actually happens when a Gtk::Plug is embedded inside a Gtk::Socket within the same application.

To reliably find the toplevel Gtk::Window, use get_toplevel() and check if the T::OPLEVEL flags is set on the result.

     GtkWidget* toplevel = gtk_widget_get_toplevel (widget);
     if (GTK_WIDGET_TOPLEVEL (toplevel))
     {
     [ Perform action on toplevel. ]
     }

Returns:
  The topmost ancestor of widget, or widget itself if there's no ancestor.

Glib::RefPtr<Gdk::Visual> Gtk::Widget::get_visual | ( |  | ) |

Gets the visual that will be used to render widget.

Returns:
  The visual for widget.

int Gtk::Widget::get_width | ( |  | ) | const

Glib::RefPtr<const Gdk::Window> Gtk::Widget::get_window | ( |  | ) | const

Glib::RefPtr<Gdk::Window> Gtk::Widget::get_window | ( |  | ) |

const GtkWidget* Gtk::Widget::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Atk::Implementor.

Reimplemented in Gtk::AboutDialog, Gtk::AccelLabel, Gtk::Alignment, Gtk::Arrow, Gtk::AspectFrame, Gtk::Assistant, Gtk::Bin, Gtk::Box, Gtk::VBox, Gtk::HBox, Gtk::Button, Gtk::ButtonBox, Gtk::VButtonBox, Gtk::HButtonBox, Gtk::Calendar, Gtk::CellView, Gtk::CheckButton, Gtk::CheckMenuItem, Gtk::ColorButton, Gtk::ColorSelection, Gtk::ColorSelectionDialog, Gtk::ComboDropDownItem, Gtk::ComboDropDown, Gtk::Combo, Gtk::ComboBox, Gtk::ComboBoxEntry, Gtk::Container, Gtk::Curve, Gtk::GammaCurve, Gtk::Dialog, Gtk::DrawingArea, Gtk::Entry, Gtk::EventBox, Gtk::Expander, Gtk::FileChooserButton, Gtk::FileChooserDialog, Gtk::FileChooserWidget, Gtk::FileSelection, Gtk::Fixed, Gtk::FontButton, Gtk::FontSelection, Gtk::FontSelectionDialog, Gtk::Frame, Gtk::HandleBox, Gtk::IconView, Gtk::Image, Gtk::ImageMenuItem, Gtk::InputDialog, Gtk::Invisible, Gtk::Item, Gtk::Label, Gtk::Layout, Gtk::LinkButton, Gtk::Menu, Gtk::MenuBar, Gtk::MenuItem, Gtk::MenuShell, Gtk::MenuToolButton, Gtk::MessageDialog, Gtk::Misc, Gtk::Notebook, Gtk::OptionMenu, Gtk::PageSetupUnixDialog, Gtk::Paned, Gtk::HPaned, Gtk::VPaned, Gtk::Plug, Gtk::PrintUnixDialog, Gtk::ProgressBar, Gtk::RadioButton, Gtk::RadioMenuItem, Gtk::RadioToolButton, Gtk::Range, Gtk::RecentChooserDialog, Gtk::RecentChooserMenu, Gtk::RecentChooserWidget, Gtk::Ruler, Gtk::VRuler, Gtk::HRuler, Gtk::Scale, Gtk::VScale, Gtk::HScale, Gtk::ScaleButton, Gtk::Scrollbar, Gtk::VScrollbar, Gtk::HScrollbar, Gtk::ScrolledWindow, Gtk::Separator, Gtk::VSeparator, Gtk::HSeparator, Gtk::SeparatorMenuItem, Gtk::SeparatorToolItem, Gtk::Socket, Gtk::SpinButton, Gtk::Statusbar, Gtk::Table, Gtk::TearoffMenuItem, Gtk::TextView, Gtk::ToggleButton, Gtk::ToggleToolButton, Gtk::Toolbar, Gtk::ToolButton, Gtk::ToolItem, Gtk::TreeView, Gtk::Viewport, Gtk::VolumeButton, and Gtk::Window.

References Glib::ValueBase::gobject_.

GtkWidget* Gtk::Widget::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Atk::Implementor.

Reimplemented in Gtk::AboutDialog, Gtk::AccelLabel, Gtk::Alignment, Gtk::Arrow, Gtk::AspectFrame, Gtk::Assistant, Gtk::Bin, Gtk::Box, Gtk::VBox, Gtk::HBox, Gtk::Button, Gtk::ButtonBox, Gtk::VButtonBox, Gtk::HButtonBox, Gtk::Calendar, Gtk::CellView, Gtk::CheckButton, Gtk::CheckMenuItem, Gtk::ColorButton, Gtk::ColorSelection, Gtk::ColorSelectionDialog, Gtk::ComboDropDownItem, Gtk::ComboDropDown, Gtk::Combo, Gtk::ComboBox, Gtk::ComboBoxEntry, Gtk::Container, Gtk::Curve, Gtk::GammaCurve, Gtk::Dialog, Gtk::DrawingArea, Gtk::Entry, Gtk::EventBox, Gtk::Expander, Gtk::FileChooserButton, Gtk::FileChooserDialog, Gtk::FileChooserWidget, Gtk::FileSelection, Gtk::Fixed, Gtk::FontButton, Gtk::FontSelection, Gtk::FontSelectionDialog, Gtk::Frame, Gtk::HandleBox, Gtk::IconView, Gtk::Image, Gtk::ImageMenuItem, Gtk::InputDialog, Gtk::Invisible, Gtk::Item, Gtk::Label, Gtk::Layout, Gtk::LinkButton, Gtk::Menu, Gtk::MenuBar, Gtk::MenuItem, Gtk::MenuShell, Gtk::MenuToolButton, Gtk::MessageDialog, Gtk::Misc, Gtk::Notebook, Gtk::OptionMenu, Gtk::PageSetupUnixDialog, Gtk::Paned, Gtk::HPaned, Gtk::VPaned, Gtk::Plug, Gtk::PrintUnixDialog, Gtk::ProgressBar, Gtk::RadioButton, Gtk::RadioMenuItem, Gtk::RadioToolButton, Gtk::Range, Gtk::RecentChooserDialog, Gtk::RecentChooserMenu, Gtk::RecentChooserWidget, Gtk::Ruler, Gtk::VRuler, Gtk::HRuler, Gtk::Scale, Gtk::VScale, Gtk::HScale, Gtk::ScaleButton, Gtk::Scrollbar, Gtk::VScrollbar, Gtk::HScrollbar, Gtk::ScrolledWindow, Gtk::Separator, Gtk::VSeparator, Gtk::HSeparator, Gtk::SeparatorMenuItem, Gtk::SeparatorToolItem, Gtk::Socket, Gtk::SpinButton, Gtk::Statusbar, Gtk::Table, Gtk::TearoffMenuItem, Gtk::TextView, Gtk::ToggleButton, Gtk::ToggleToolButton, Gtk::Toolbar, Gtk::ToolButton, Gtk::ToolItem, Gtk::TreeView, Gtk::Viewport, Gtk::VolumeButton, and Gtk::Window.

References Glib::ValueBase::gobject_.

void Gtk::Widget::grab_default | ( |  | ) |

Causes widget to become the default widget.

widget must have the Gtk::CAN_DEFAULT flag set; typically you have to set this flag yourself by calling `GTK_WIDGET_SET_FLAGS ( widget, GTK_CAN_DEFAULT)`. The default widget is activated when the user presses Enter in a window. Default widgets must be activatable, that is, activate() should affect them.

void Gtk::Widget::grab_focus | ( |  | ) |

Causes widget to have the keyboard focus for the Gtk::Window it's inside.

widget must be a focusable widget, such as a Gtk::Entry; something like Gtk::Frame won't work. (More precisely, it must have the Gtk::CAN_FOCUS flag set.)

bool Gtk::Widget::has_default | ( |  | ) | const

bool Gtk::Widget::has_focus | ( |  | ) | const

bool Gtk::Widget::has_grab | ( |  | ) | const

bool Gtk::Widget::has_no_window | ( |  | ) | const

bool Gtk::Widget::has_screen | ( |  | ) | const

Checks whether there is a Gdk::Screen is associated with this widget.

All toplevel widgets have an associated screen, and all widgets added into a heirarchy with a toplevel window at the top.

Returns:
  `true` if there is a Gdk::Screen associcated with the widget.

Since gtkmm 2.2:

void Gtk::Widget::hide | ( |  | ) |

Reverses the effects of show(), causing the widget to be hidden (invisible to the user).

void Gtk::Widget::hide_all | ( |  | ) |

Recursively hides a widget and any child widgets.

virtual void Gtk::Widget::hide_all_vfunc | ( |  | ) | `[protected, virtual]`

void Gtk::Widget::input_shape_combine_mask | ( | const Glib::RefPtr<const Gdk::Bitmap>& | shape_mask,
|  | int | offset_x,
|  | int | offset_y |
| ) |  |  |

Sets an input shape for this widget's GDK window.

This allows for windows which react to mouse click in a nonrectangular region, see gdk_window_input_shape_combine_mask() for more information.

Since gtkmm 2.10:

Parameters:

  | shape_mask | Shape to be added, or `0` to remove an existing shape.
  | offset_x | X position of shape mask with respect to window.
  | offset_y | Y position of shape mask with respect to window.

bool Gtk::Widget::intersect | ( | const Gdk::Rectangle& | area,
|  | Gdk::Rectangle& | intersection |
| ) |  |  | const

Computes the intersection of a widget's area and area, storing the intersection in intersection, and returns `true` if there was an intersection.

intersection may be `0` if you're only interested in whether there was an intersection.

Parameters:

  | area | A rectangle.
  | intersection | Rectangle to store intersection of widget and area.

Returns:
  `true` if there was an intersection.

bool Gtk::Widget::intersect | ( | const Gdk::Rectangle& | area | ) | const

bool Gtk::Widget::is_ancestor | ( | Widget& | ancestor | ) | const

Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.

Parameters:

  | ancestor | Another Gtk::Widget.

Returns:
  `true` if ancestor contains widget as a child, grandchild, great grandchild, etc.

bool Gtk::Widget::is_composite_child | ( |  | ) | const

bool Gtk::Widget::is_composited | ( |  | ) | const

Whether widget can rely on having its alpha channel drawn correctly.

On X11 this function returns whether a compositing manager is running for widget's screen.

Returns:
  `true` if the widget can rely on its alpha channel being drawn correctly.

Since gtkmm 2.10:

bool Gtk::Widget::is_drawable | ( |  | ) | const

bool Gtk::Widget::is_focus | ( |  | ) | const

Determines if the widget is the focus widget within its toplevel.

(This does not mean that the HAS_FOCUS flag is necessarily set; HAS_FOCUS will only be set if the toplevel widget additionally has the global input focus.)

Returns:
  `true` if the widget is the focus widget.

bool Gtk::Widget::is_mapped | ( |  | ) | const

bool Gtk::Widget::is_realized | ( |  | ) | const

bool Gtk::Widget::is_sensitive | ( |  | ) | const

bool Gtk::Widget::is_toplevel | ( |  | ) | const

Reimplemented in Gtk::Window.

bool Gtk::Widget::is_visible | ( |  | ) | const

bool Gtk::Widget::keynav_failed | ( | DirectionType | direction | ) |

This function should be called whenever keyboard navigation within a single widget hits a boundary.

The function emits the Gtk::Widget::keynav-changed signal on the widget and its return value should be interpreted in a way similar to the return value of child_focus():

When `true` is returned, stay in the widget, the failed keyboard navigation is Ok and/or there is nowhere we can/should move the focus to.

When `false` is returned, the caller should continue with keyboard navigation outside the widget, e.g. by calling child_focus() on the widget's toplevel.

The default keynav-failed handler returns `true` for Gtk::DIR_TAB_FORWARD and Gtk::DIR_TAB_BACKWARD. For the other values of Gtk::DirectionType, it looks at the Gtk::Settings:gtk-keynav-cursor-only" setting and returns `false` if the setting is `true`. This way the entire user interface becomes cursor-navigatable on input devices such as mobile phones which only have cursor keys but no tab key.

Whenever the default handler returns `true`, it also calls error_bell() to notify the user of the failed keyboard navigation.

A use case for providing an own implementation of keynav-failed (either by connecting to it or by overriding it) would be a row of Gtk::Entry widgets where the user should be able to navigate the entire row with the cursor keys, as e.g. known from user interfaces that require entering license keys.

Parameters:

  | direction | Direction of focus movement.

Returns:
  `true` if stopping keyboard navigation is fine, `false` if the emitting widget should try to handle the keyboard navigation attempt in its parent container(s).

Since gtkmm 2.12:

Glib::ListHandle<const Widget*> Gtk::Widget::list_mnemonic_labels | ( |  | ) | const

Return value: the list of mnemonic labels; free this list.

Returns:
  The list of mnemonic labels; free this list with Glib::list_free() when you are done with it.

Since gtkmm 2.4:

Glib::ListHandle<Widget*> Gtk::Widget::list_mnemonic_labels | ( |  | ) |

Return value: the list of mnemonic labels; free this list.

Returns:
  The list of mnemonic labels; free this list with Glib::list_free() when you are done with it.

Since gtkmm 2.4:

void Gtk::Widget::map | ( |  | ) |

This function is only for use in widget implementations.

Causes a widget to be mapped if it isn't already.

bool Gtk::Widget::mnemonic_activate | ( | bool | group_cycling | ) |

void Gtk::Widget::modify_base | ( | StateType | state,
|  | const Gdk::Color& | color |
| ) |  |  |

Sets the base color for a widget in a particular state.

All other style values are left untouched. The base color is the background color used along with the text color (see modify_text() ) for widgets such as Gtk::Entry and Gtk::TextView. See also modify_style() and unset_base().

Parameters:

  | state | The state for which to set the text color.
  | color | The color to assign (does not need to be allocated). Sets the base color for a widget in a particular state. All other style values are left untouched. The base color is the background color used along with the text color (see modify_text()) for widgets such as Gtk::Entry and Gtk::TextView. See also modify_style().
  | state | The state for which to set the base color.
  | color | The color to assign (does not need to be allocated).

void Gtk::Widget::modify_bg | ( | StateType | state,
|  | const Gdk::Color& | color |
| ) |  |  |

Sets the background color for a widget in a particular state.

All other style values are left untouched. See also modify_style() and unset_bg().

Parameters:

  | state | The state for which to set the background color.
  | color | The color to assign (does not need to be allocated). Sets the background color for a widget in a particular state. All other style values are left untouched. See also modify_style().
  | state | The state for which to set the background color.
  | color | The color to assign (does not need to be allocated).

void Gtk::Widget::modify_bg_pixmap | ( | StateType | state,
|  | const Glib::ustring & | pixmap_name |
| ) |  |  |

void Gtk::Widget::modify_cursor | ( | const Gdk::Color& | primary,
|  | const Gdk::Color& | secondary |
| ) |  |  |

Sets the cursor color to use in a widget, overriding the cursor_color and secondary_cursor_color style properties.

All other style values are left untouched. See also modify_style(). See also unset_cursor().

Parameters:

  | primary | the color to use for primary cursor (does not need to be allocated).
  | secondary | the color to use for secondary cursor (does not need to be allocated).

Since gtkmm 2.12:

Sets the cursor color to use in a widget, overriding the Gtk::Widget:cursor-color and Gtk::Widget:secondary-cursor-color style properties. All other style values are left untouched. See also modify_style().

Since gtkmm 2.12:

Parameters:

  | primary | The color to use for primary cursor (does not need to be allocated), or `0` to undo the effect of previous calls to of modify_cursor().
  | secondary | The color to use for secondary cursor (does not need to be allocated), or `0` to undo the effect of previous calls to of modify_cursor().

void Gtk::Widget::modify_fg | ( | StateType | state,
|  | const Gdk::Color& | color |
| ) |  |  |

Sets the foreground color for a widget in a particular state.

All other style values are left untouched. See also modify_style() and unset_fg().

Parameters:

  | state | The state for which to set the foreground color.
  | color | The color to assign (does not need to be allocated). Sets the foreground color for a widget in a particular state. All other style values are left untouched. See also modify_style().
  | state | The state for which to set the foreground color.
  | color | The color to assign (does not need to be allocated).

void Gtk::Widget::modify_font | ( | const Pango::FontDescription & | font_desc | ) |

Sets the font to use for a widget.

All other style values are left untouched. See also modify_style() and unset_font(). Sets the font to use for a widget. All other style values are left untouched. See also modify_style().

Parameters:

  | font_desc | The font description to use.

void Gtk::Widget::modify_style | ( | const Glib::RefPtr<RcStyle>& | style | ) |

Modifies style values on the widget.

Modifications made using this technique take precedence over style values set via an RC file, however, they will be overriden if a style is explicitely set on the widget using set_style(). The Gtk::RcStyle structure is designed so each field can either be set or unset, so it is possible, using this function, to modify some style values and leave the others unchanged.

Note that modifications made with this function are not cumulative with previous calls to modify_style() or with such functions as modify_fg(). If you wish to retain previous values, you must first call get_modifier_style(), make your modifications to the returned style, then call modify_style() with that style. On the other hand, if you first call modify_style(), subsequent calls to such functions modify_fg() will have a cumulative effect with the initial modifications.

Parameters:

  | style | The Gtk::RcStyle holding the style modifications.

void Gtk::Widget::modify_text | ( | StateType | state,
|  | const Gdk::Color& | color |
| ) |  |  |

Sets the text color for a widget in a particular state.

All other style values are left untouched. The text color is the foreground color used along with the base color (see modify_base() ) for widgets such as Gtk::Entry and Gtk::TextView. See also modify_style() and unset_text().

Parameters:

  | state | The state for which to set the text color.
  | color | The color to assign (does not need to be allocated). Sets the text color for a widget in a particular state. All other style values are left untouched. The text color is the foreground color used along with the base color (see modify_base()) for widgets such as Gtk::Entry and Gtk::TextView. See also modify_style().
  | state | The state for which to set the text color.
  | color | The color to assign (does not need to be allocated).

virtual bool Gtk::Widget::on_button_press_event | ( | GdkEventButton * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_button_release_event | ( | GdkEventButton * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_child_notify | ( | GParamSpec * | pspec | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_client_event | ( | GdkEventClient * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_configure_event | ( | GdkEventConfigure * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_delete_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_direction_changed | ( | TextDirection | direction | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_drag_begin | ( | const Glib::RefPtr<Gdk::DragContext>& | context | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_drag_data_delete | ( | const Glib::RefPtr<Gdk::DragContext>& | context | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_drag_data_get | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | SelectionData& | selection_data,
|  | guint | info,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::Widget::on_drag_data_received | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | int | x,
|  | int | y,
|  | const SelectionData& | selection_data,
|  | guint | info,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual bool Gtk::Widget::on_drag_drop | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | int | x,
|  | int | y,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual void Gtk::Widget::on_drag_end | ( | const Glib::RefPtr<Gdk::DragContext>& | context | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_drag_leave | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual bool Gtk::Widget::on_drag_motion | ( | const Glib::RefPtr<Gdk::DragContext>& | context,
|  | int | x,
|  | int | y,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual bool Gtk::Widget::on_enter_notify_event | ( | GdkEventCrossing * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_event | ( | GdkEvent * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_expose_event | ( | GdkEventExpose * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_focus | ( | DirectionType | direction | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_focus_in_event | ( | GdkEventFocus * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_focus_out_event | ( | GdkEventFocus * | event | ) | `[protected, virtual]`

virtual Glib::RefPtr<Atk::Object> Gtk::Widget::on_get_accessible | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_grab_focus | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_grab_notify | ( | bool | was_grabbed | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_hide | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_hierarchy_changed | ( | Widget* | previous_toplevel | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_key_press_event | ( | GdkEventKey * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_key_release_event | ( | GdkEventKey * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_leave_notify_event | ( | GdkEventCrossing * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_map | ( |  | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_map_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_mnemonic_activate | ( | bool | group_cycling | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_motion_notify_event | ( | GdkEventMotion * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_no_expose_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_parent_changed | ( | Widget* | previous_parent | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_property_notify_event | ( | GdkEventProperty * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_proximity_in_event | ( | GdkEventProximity * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_proximity_out_event | ( | GdkEventProximity * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_realize | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_screen_changed | ( | const Glib::RefPtr<Gdk::Screen>& | previous_screen | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_scroll_event | ( | GdkEventScroll * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_selection_clear_event | ( | GdkEventSelection * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_selection_get | ( | SelectionData& | selection_data,
|  | guint | info,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual bool Gtk::Widget::on_selection_notify_event | ( | GdkEventSelection * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_selection_received | ( | const SelectionData& | selection_data,
|  | guint | time |
| ) |  |  | `[protected, virtual]`

virtual bool Gtk::Widget::on_selection_request_event | ( | GdkEventSelection * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_show | ( |  | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_size_allocate | ( | Allocation& | allocation | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_size_request | ( | Requisition* | requisition | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_state_changed | ( | Gtk::StateType | previous_state | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_style_changed | ( | const Glib::RefPtr<Gtk::Style>& | previous_style | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_unmap | ( |  | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_unmap_event | ( | GdkEventAny * | event | ) | `[protected, virtual]`

virtual void Gtk::Widget::on_unrealize | ( |  | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_visibility_notify_event | ( | GdkEventVisibility * | event | ) | `[protected, virtual]`

virtual bool Gtk::Widget::on_window_state_event | ( | GdkEventWindowState * | event | ) | `[protected, virtual]`

bool Gtk::Widget::parent_sensitive | ( |  | ) | const

void Gtk::Widget::path | ( | Glib::ustring & | path,
|  | Glib::ustring & | path_reversed |
| ) |  |  |

Compute a widget's path of the form "GtkWindow.MyLabel".

static void Gtk::Widget::pop_colormap | ( |  | ) | `[static]`

Removes a colormap pushed with push_colormap().

static void Gtk::Widget::pop_composite_child | ( |  | ) | `[static]`

Cancels the effect of a previous call to push_composite_child().

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_app_paintable | ( |  | ) | const

Whether the application will paint directly on the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_app_paintable | ( |  | ) |

Whether the application will paint directly on the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_can_default | ( |  | ) | const

Whether the widget can be the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_can_default | ( |  | ) |

Whether the widget can be the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_can_focus | ( |  | ) | const

Whether the widget can accept the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_can_focus | ( |  | ) |

Whether the widget can accept the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_composite_child | ( |  | ) | const

Whether the widget is part of a composite widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Gdk::EventMask> Gtk::Widget::property_events | ( |  | ) | const

The event mask that decides what kind of GdkEvents this widget gets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Gdk::EventMask> Gtk::Widget::property_events | ( |  | ) |

The event mask that decides what kind of GdkEvents this widget gets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Gdk::ExtensionMode> Gtk::Widget::property_extension_events | ( |  | ) | const

The mask that decides what kind of extension events this widget gets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Gdk::ExtensionMode> Gtk::Widget::property_extension_events | ( |  | ) |

The mask that decides what kind of extension events this widget gets.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_has_default | ( |  | ) | const

Whether the widget is the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_has_default | ( |  | ) |

Whether the widget is the default widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_has_focus | ( |  | ) | const

Whether the widget has the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_has_focus | ( |  | ) |

Whether the widget has the input focus.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_has_tooltip | ( |  | ) | const

Whether this widget has a tooltip.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_has_tooltip | ( |  | ) |

Whether this widget has a tooltip.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::Widget::property_height_request | ( |  | ) | const

Override for height request of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Widget::property_height_request | ( |  | ) |

Override for height request of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::Widget::property_name | ( |  | ) | const

The name of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Reimplemented in Gtk::AboutDialog.

Glib::PropertyProxy<Glib::ustring> Gtk::Widget::property_name | ( |  | ) |

The name of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Reimplemented in Gtk::AboutDialog.

Glib::PropertyProxy_ReadOnly<Container*> Gtk::Widget::property_parent | ( |  | ) | const

The parent widget of this widget.

Must be a Container widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Container*> Gtk::Widget::property_parent | ( |  | ) |

The parent widget of this widget.

Must be a Container widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_receives_default | ( |  | ) | const

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_receives_default | ( |  | ) |

If TRUE.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_sensitive | ( |  | ) | const

Whether the widget responds to input.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_sensitive | ( |  | ) |

Whether the widget responds to input.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::RefPtr<Style>> Gtk::Widget::property_style | ( |  | ) | const

The style of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::RefPtr<Style>> Gtk::Widget::property_style | ( |  | ) |

The style of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::Widget::property_tooltip_markup | ( |  | ) | const

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gtk::Widget::property_tooltip_markup | ( |  | ) |

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::ustring> Gtk::Widget::property_tooltip_text | ( |  | ) | const

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<Glib::ustring> Gtk::Widget::property_tooltip_text | ( |  | ) |

The contents of the tooltip for this widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::Widget::property_visible | ( |  | ) | const

Whether the widget is visible.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::Widget::property_visible | ( |  | ) |

Whether the widget is visible.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<int> Gtk::Widget::property_width_request | ( |  | ) | const

Override for width request of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<int> Gtk::Widget::property_width_request | ( |  | ) |

Override for width request of the widget.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<Glib::RefPtr<Gdk::Window>> Gtk::Widget::property_window | ( |  | ) | const

The widget's window if it is realized.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

static void Gtk::Widget::push_colormap | ( | const Glib::RefPtr<const Gdk::Colormap>& | cmap | ) | `[static]`

Pushes cmap onto a global stack of colormaps; the topmost colormap on the stack will be used to create all widgets.

Remove cmap with pop_colormap(). There's little reason to use this function.

Parameters:

  | cmap | A Gdk::Colormap.

static void Gtk::Widget::push_composite_child | ( |  | ) | `[static]`

Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call.

A composite child is a child that's an implementation detail of the container it's inside and should not be visible to people using the container. Composite children aren't treated differently by GTK (but see Gtk::Container::foreach() vs. Gtk::Container::forall()), but e.g. GUI builders might want to treat them in a different way.

Here is a simple example:

     gtk_widget_push_composite_child (&lt;!-- --&gt;);
     scrolled_window->hscrollbar = gtk_hscrollbar_new (hadjustment);
     gtk_widget_set_composite_name (scrolled_window->hscrollbar, "hscrollbar");
     gtk_widget_pop_composite_child (&lt;!-- --&gt;);
     gtk_widget_set_parent (scrolled_window->hscrollbar,
     GTK_WIDGET (scrolled_window));
     g_object_ref (scrolled_window->hscrollbar);

void Gtk::Widget::queue_draw | ( |  | ) |

Equivalent to calling queue_draw_area() for the entire area of a widget.

void Gtk::Widget::queue_draw_area | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height |
| ) |  |  |

Invalidates the rectangular area of widget defined by x, y, width and height by calling gdk_window_invalidate_rect() on the widget's window and all its child windows.

Once the main loop becomes idle (after the current batch of events has been processed, roughly), the window will receive expose events for the union of all regions that have been invalidated.

Normally you would only use this function in widget implementations. You might also use it, or gdk_window_invalidate_rect() directly, to schedule a redraw of a Gtk::DrawingArea or some portion thereof.

Frequently you can just call gdk_window_invalidate_rect() or gdk_window_invalidate_region() instead of this function. Those functions will invalidate only a single window, instead of the widget and all its children.

The advantage of adding to the invalidated region compared to simply drawing immediately is efficiency; using an invalid region ensures that you only have to redraw one time.

Parameters:

  | x | X coordinate of upper-left corner of rectangle to redraw.
  | y | Y coordinate of upper-left corner of rectangle to redraw.
  | width | Width of region to draw.
  | height | Height of region to draw.

void Gtk::Widget::queue_resize | ( |  | ) |

This function is only for use in widget implementations.

Flags a widget to have its size renegotiated; should be called when a widget for some reason has a new size request. For example, when you change the text in a Gtk::Label, Gtk::Label queues a resize to ensure there's enough space for the new text.

void Gtk::Widget::queue_resize_no_redraw | ( |  | ) |

This function works like queue_resize(), except that the widget is not invalidated.

Since gtkmm 2.4:

bool Gtk::Widget::rc_style | ( |  | ) | const

void Gtk::Widget::realize | ( |  | ) | `[protected]`

Creates the GDK (windowing system) resources associated with a widget.

For example, widget->window will be created when a widget is realized. Normally realization happens implicitly; if you show a widget and all its parent containers, then the widget will be realized and mapped automatically.

Realizing a widget requires all the widget's parent widgets to be realized; calling realize() realizes the widget's parents in addition to widget itself. If a widget is not yet inside a toplevel window when you realize it, bad things will happen.

This function is primarily used in widget implementations, and isn't very useful otherwise. Many times when you think you might need it, a better approach is to connect to a signal that will be called after the widget is realized automatically, such as GtkWidget::expose-event. Or simply Glib::signal_connect_after() to the GtkWidget::realize signal.

void Gtk::Widget::realize_if_needed | ( |  | ) | `[protected]`

bool Gtk::Widget::receives_default | ( |  | ) | const

Gdk::Region Gtk::Widget::region_intersect | ( | const Gdk::Region& | region | ) | const

Computes the intersection of a widget's area and region, returning the intersection.

The result may be empty, use gdk_region_empty() to check.

Parameters:

  | region | A Gdk::Region, in the same coordinate system as widget->allocation. That is, relative to widget->window for NO_WINDOW widgets; relative to the parent window of widget->window for widgets with their own window.

Returns:
  A newly allocated region holding the intersection of widget and region. The coordinates of the return value are relative to widget->window for NO_WINDOW widgets, and relative to the parent window of widget->window for widgets with their own window.

bool Gtk::Widget::remove_accelerator | ( | const Glib::RefPtr<AccelGroup>& | accel_group,
|  | guint | accel_key,
|  | Gdk::ModifierType | accel_mods |
| ) |  |  |

Removes an accelerator from widget, previously installed with add_accelerator().

Parameters:

  | accel_group | Accel group for this widget.
  | accel_key | GDK keyval of the accelerator.
  | accel_mods | Modifier key combination of the accelerator.

Returns:
  Whether an accelerator was installed and could be removed.

void Gtk::Widget::remove_mnemonic_label | ( | Widget& | label | ) |

Removes a widget from the list of mnemonic labels for this widget.

(See list_mnemonic_labels()). The widget must have previously been added to the list with add_mnemonic_label().

Since gtkmm 2.4:

Parameters:

  | label | A Gtk::Widget that was previously set as a mnemnic label for widget with add_mnemonic_label().

void Gtk::Widget::remove_modal_grab | ( |  | ) |

Remove the modal grab of the widget in case it was previously grabbed.

Glib::RefPtr<Gdk::Pixbuf> Gtk::Widget::render_icon | ( | const StockID& | stock_id,
|  | IconSize | size,
|  | const Glib::ustring & | detail = `Glib::ustring()` |
| ) |  |  |

A convenience function that uses the theme engine and RC file settings for the widget to look up stock_id and render it to a pixbuf.

stock_id should be a stock icon ID such as Gtk::STOCK_OPEN or Gtk::STOCK_OK. size should be a size such as Gtk::ICON_SIZE_MENU. detail should be a string that identifies the widget or code doing the rendering, so that theme engines can special-case rendering for that widget or code.

The pixels in the returned Gdk::Pixbuf are shared with the rest of the application and should not be modified. The pixbuf should be freed after use with Glib::object_unref().

Parameters:

  | stock_id | A stock ID.
  | size | A stock size. A size of (GtkIconSize)-1 means render at the size of the source and don't scale (if there are multiple source sizes, GTK+ picks one of the available sizes).
  | detail | Render detail to pass to theme engine.

Returns:
  A new pixbuf if the stock ID was known.

void Gtk::Widget::reparent | ( | Widget& | new_parent | ) |

Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget.

Parameters:

  | new_parent | A Gtk::Container to move the widget into.

void Gtk::Widget::reset_rc_styles | ( |  | ) |

void Gtk::Widget::reset_shapes | ( |  | ) |

Recursively resets the shape on this widget and its descendants.

int Gtk::Widget::send_expose | ( | GdkEvent * | event | ) |

Very rarely-used function.

This function is used to emit an expose event signals on a widget. This function is not normally used directly. The only time it is used is when propagating an expose event to a child NO_WINDOW widget, and that is normally done using Gtk::Container::propagate_expose().

If you want to force an area of a window to be redrawn, use gdk_window_invalidate_rect() or gdk_window_invalidate_region(). To cause the redraw to be done immediately, follow that call with a call to gdk_window_process_updates().

Parameters:

  | event | A expose Gdk::Event.

Returns:
  Return from the event signal emission (`true` if the event was handled).

bool Gtk::Widget::sensitive | ( |  | ) | const

void Gtk::Widget::set_accel_path | ( | const Glib::ustring & | accel_path,
|  | const Glib::RefPtr<AccelGroup>& | accel_group |
| ) |  |  |

Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated.

This removes any accelerators (for any accelerator group) installed by previous calls to set_accel_path(). Associating accelerators with paths allows them to be modified by the user and the modifications to be saved for future use. (See gtk_accel_map_save().)

This function is a low level function that would most likely be used by a menu creation system like Gtk::UIManager. If you use Gtk::UIManager, setting up accelerator paths will be done automatically.

Even when you you aren't using Gtk::UIManager, if you only want to set up accelerators on menu items Gtk::MenuItem::set_accel_path() provides a somewhat more convenient interface.

Parameters:

  | accel_path | Path used to look up the accelerator.
  | accel_group | A Gtk::AccelGroup.

void Gtk::Widget::set_allocation | ( | const Allocation& | value | ) | `[protected]`

void Gtk::Widget::set_app_paintable | ( | bool | app_paintable = `true` | ) |

Sets whether the application intends to draw on the widget in an Gtk::Widget::expose-event handler.

This is a hint to the widget and does not affect the behavior of the GTK+ core; many widgets ignore this flag entirely. For widgets that do pay attention to the flag, such as Gtk::EventBox and Gtk::Window, the effect is to suppress default themed drawing of the widget's background. (Children of the widget will still be drawn.) The application is then entirely responsible for drawing the widget background.

Note that the background is still drawn when the widget is mapped. If this is not suitable (e.g. because you want to make a transparent window using an RGBA visual), you can work around this by doing:

     gtk_widget_realize (window);
     gdk_window_set_back_pixmap (window->window, <tt>0</tt>, <tt>false</tt>);
     gtk_widget_show (window);

Parameters:

  | app_paintable | `true` if the application will paint on the widget.

void Gtk::Widget::set_child_visible | ( | bool | is_visible = `true` | ) |

Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show().

The child visibility can be set for widget before it is added to a container with set_parent(), to avoid mapping children unnecessary before immediately unmapping them. However it will be reset to its default state of `true` when the widget is removed from a container.

Note that changing the child visibility of a widget does not queue a resize on the widget. Most of the time, the size of a widget is computed from all visible children, whether or not they are mapped. If this is not the case, the container can queue a resize itself.

This function is only useful for container implementations and never should be called by an application.

Parameters:

  | is_visible | If `true`, widget should be mapped along with its parent.

void Gtk::Widget::set_colormap | ( | const Glib::RefPtr<const Gdk::Colormap>& | colormap | ) |

Sets the colormap for the widget to the given value.

Widget must not have been previously realized. This probably should only be used from an `init()` function (i.e. from the constructor for the widget).

Parameters:

  | colormap | A colormap.

void Gtk::Widget::set_composite_name | ( | const Glib::ustring & | name | ) |

Sets a widgets composite name.

The widget must be a composite child of its parent; see push_composite_child().

Parameters:

  | name | The name to set.

static void Gtk::Widget::set_default_colormap | ( | const Glib::RefPtr<const Gdk::Colormap>& | colormap | ) | `[static]`

Sets the default colormap to use when creating widgets.

push_colormap() is a better function to use if you only want to affect a few widgets, rather than all widgets.

Parameters:

  | colormap | A Gdk::Colormap.

static void Gtk::Widget::set_default_direction | ( | TextDirection | dir | ) | `[static]`

Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction().

Parameters:

  | dir | The new default direction. This cannot be Gtk::TEXT_DIR_NONE.

void Gtk::Widget::set_direction | ( | TextDirection | dir | ) |

Sets the reading direction on a particular widget.

This direction controls the primary direction for widgets containing text, and also the direction in which the children of a container are packed. The ability to set the direction is present in order so that correct localization into languages with right-to-left reading directions can be done. Generally, applications will let the default reading direction present, except for containers where the containers are arranged in an order that is explicitely visual rather than logical (such as buttons for text justification).

If the direction is set to Gtk::TEXT_DIR_NONE, then the value set by set_default_direction() will be used.

Parameters:

  | dir | The new direction.

void Gtk::Widget::set_double_buffered | ( | bool | double_buffered = `true` | ) |

Widgets are double buffered by default; you can use this function to turn off the buffering.

"Double buffered" simply means that gdk_window_begin_paint_region() and gdk_window_end_paint() are called automatically around expose events sent to the widget. gdk_window_begin_paint() diverts all drawing to a widget's window to an offscreen buffer, and gdk_window_end_paint() draws the buffer to the screen. The result is that users see the window update in one smooth step, and don't see individual graphics primitives being rendered.

In very simple terms, double buffered widgets don't flicker, so you would only use this function to turn off double buffering if you had special needs and really knew what you were doing.

Note:
  if you turn off double-buffering, you have to handle expose events, since even the clearing to the background color or pixmap will not happen automatically (as it is done in gdk_window_begin_paint()).

Parameters:

  | double_buffered | `true` to double-buffer a widget.

void Gtk::Widget::set_events | ( | Gdk::EventMask | events | ) |

Sets the event mask (see Gdk::EventMask) for a widget.

The event mask determines which events a widget will receive. Keep in mind that different widgets have different default event masks, and by changing the event mask you may disrupt a widget's functionality, so be careful. This function must be called while a widget is unrealized. Consider add_events() for widgets that are already realized, or if you want to preserve the existing event mask. This function can't be used with Gtk::NO_WINDOW widgets; to get events on those widgets, place them inside a Gtk::EventBox and receive events on the event box.

Parameters:

  | events | Event mask.

void Gtk::Widget::set_extension_events | ( | Gdk::ExtensionMode | mode | ) |

Sets the extension events mask to mode.

See Gdk::ExtensionMode and gdk_input_set_extension_events().

Parameters:

  | mode | Bitfield of extension events to receive.

void Gtk::Widget::set_flags | ( | WidgetFlags | flags | ) |

void Gtk::Widget::set_has_tooltip | ( | bool | has_tooltip = `TRUE` | ) |

Sets the has-tooltip property on widget to has_tooltip.

See GtkWidget:has-tooltip for more information.

Since gtkmm 2.12:

Parameters:

  | has_tooltip | Whether or not widget has a tooltip.

void Gtk::Widget::set_name | ( | const Glib::ustring & | name | ) |

Widgets can be named, which allows you to refer to them from a gtkrc file.

You can apply a style to widgets with a particular name in the gtkrc file. See the documentation for gtkrc files (on the same page as the docs for Gtk::RcStyle).

Note that widget names are separated by periods in paths (see path()), so names with embedded periods may cause confusion.

Parameters:

  | name | Name for the widget.

Reimplemented in Gtk::AboutDialog.

void Gtk::Widget::set_no_show_all | ( | bool | no_show_all = `true` | ) |

Sets the Gtk::Widget:no-show-all property, which determines whether calls to show_all() and hide_all() will affect this widget.

This is mostly for use in constructing widget hierarchies with externally controlled visibility, see Gtk::UIManager.

Since gtkmm 2.4:

Parameters:

  | no_show_all | The new value for the "no-show-all" property.

void Gtk::Widget::set_parent | ( | Widget& | parent | ) |

This function is useful only when implementing subclasses of Gtk::Container.

Sets the container as the parent of widget, and takes care of some details such as updating the state and style of the child to reflect its new location. The opposite function is unparent().

Parameters:

  | parent | Parent container.

void Gtk::Widget::set_parent_window | ( | const Glib::RefPtr<const Gdk::Window>& | parent_window | ) |

Sets a non default parent window for widget.

Parameters:

  | parent_window | The new parent window.

void Gtk::Widget::set_redraw_on_allocate | ( | bool | redraw_on_allocate = `true` | ) |

Sets whether the entire widget is queued for drawing when its size allocation changes.

By default, this setting is `true` and the entire widget is redrawn on every size change. If your widget leaves the upper left unchanged when made bigger, turning this setting off will improve performance.

Note that for NO_WINDOW widgets setting this flag to `false` turns off all allocation on resizing: the widget will not even redraw if its position changes; this is to allow containers that don't draw anything to avoid excess invalidations. If you set this flag on a NO_WINDOW widget that does draw on widget->window, you are responsible for invalidating both the old and new allocation of the widget when the widget is moved and responsible for invalidating regions newly when the widget increases size.

Parameters:

  | redraw_on_allocate | If `true`, the entire widget will be redrawn when it is allocated to a new size. Otherwise, only the new portion of the widget will be redrawn.

bool Gtk::Widget::set_scroll_adjustments | ( | Adjustment& | hadjustment,
|  | Adjustment& | vadjustment |
| ) |  |  |

For widgets that support scrolling, sets the scroll adjustments and Return value: `true` if the widget supports scrolling.

Parameters:

  | hadjustment | An adjustment for horizontal scrolling, or `0`.
  | vadjustment | An adjustment for vertical scrolling, or `0`.

Returns:
  `true` if the widget supports scrolling.

void Gtk::Widget::set_sensitive | ( | bool | sensitive = `true` | ) |

Sets the sensitivity of a widget.

A widget is sensitive if the user can interact with it. Insensitive widgets are "grayed out" and the user can't interact with them. Insensitive widgets are known as "inactive", "disabled", or "ghosted" in some other toolkits.

Parameters:

  | sensitive | `true` to make the widget sensitive.

void Gtk::Widget::set_size_request | ( | int | width = `-1`,
|  | int | height = `-1` |
| ) |  |  |

Sets the minimum size of a widget; that is, the widget's size request will be width by height.

You can use this function to force a widget to be either larger or smaller than it normally would be.

In most cases, Gtk::Window::set_default_size() is a better choice for toplevel windows than this function; setting the default size will still allow users to shrink the window. Setting the size request will force them to leave the window at least as large as the size request. When dealing with window sizes, Gtk::Window::set_geometry_hints() can be a useful function as well.

Note the inherent danger of setting any fixed size - themes, translations into other languages, different fonts, and user action can all change the appropriate size for a given widget. So, it's basically impossible to hardcode a size that will always be correct.

The size request of a widget is the smallest size a widget can accept while still functioning well and drawing itself correctly. However in some strange cases a widget may be allocated less than its requested size, and in many cases a widget may be allocated more space than it requested.

If the size request in a given direction is -1 (unset), then the "natural" size request of the widget will be used instead.

Widgets can't actually be allocated a size less than 1 by 1, but you can pass 0,0 to this function to mean "as small as possible."

Parameters:

  | width | Width widget should request, or -1 to unset.
  | height | Height widget should request, or -1 to unset.

void Gtk::Widget::set_state | ( | Gtk::StateType | state | ) |

This function is for use in widget implementations.

Sets the state of a widget (insensitive, prelighted, etc.) Usually you should set the state using wrapper functions such as set_sensitive().

Parameters:

  | state | New state for widget.

void Gtk::Widget::set_style | ( | const Glib::RefPtr<Style>& | style | ) |

Sets the Gtk::Style for a widget ( widget->style).

You probably don't want to use this function; it interacts badly with themes, because themes work by replacing the Gtk::Style. Instead, use modify_style().

Parameters:

  | style | A Gtk::Style.

void Gtk::Widget::set_tooltip_markup | ( | const Glib::ustring & | markup | ) |

Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.

This function will take care of setting GtkWidget:has-tooltip to `true` and of the default handler for the GtkWidget::query-tooltip signal.

See also the GtkWidget:tooltip-markup property and gtk_tooltip_set_markup().

Since gtkmm 2.12:

Parameters:

  | markup | The contents of the tooltip for widget, or `0`.

Reimplemented in Gtk::ToolItem.

void Gtk::Widget::set_tooltip_text | ( | const Glib::ustring & | text | ) |

Sets text as the contents of the tooltip.

This function will take care of setting GtkWidget:has-tooltip to `true` and of the default handler for the GtkWidget::query-tooltip signal.

See also the GtkWidget:tooltip-text property and gtk_tooltip_set_text().

Since gtkmm 2.12:

Parameters:

  | text | The contents of the tooltip for widget.

Reimplemented in Gtk::ToolItem.

void Gtk::Widget::set_tooltip_window | ( | Window& | widget | ) |

Replaces the default, usually yellow, window used for displaying tooltips with custom_window.

GTK+ will take care of showing and hiding custom_window at the right moment, to behave likewise as the default tooltip window. If custom_window is `0`, the default tooltip window will be used.

Since gtkmm 2.12:

Parameters:

  | custom_window | A Gtk::Window, or `0`.

void Gtk::Widget::set_window | ( | const Glib::RefPtr<Gdk::Window>& | value | ) | `[protected]`

void Gtk::Widget::shape_combine_mask | ( | const Glib::RefPtr<const Gdk::Bitmap>& | shape_mask,
|  | int | offset_x,
|  | int | offset_y |
| ) |  |  |

Sets a shape for this widget's GDK window.

This allows for transparent windows etc., see gdk_window_shape_combine_mask() for more information.

Parameters:

  | shape_mask | Shape to be added.
  | offset_x | X position of shape mask with respect to window.
  | offset_y | Y position of shape mask with respect to window.

void Gtk::Widget::show | ( |  | ) |

Flags a widget to be displayed.

Any widget that isn't shown will not appear on the screen. If you want to show all the widgets in a container, it's easier to call show_all() on the container, instead of individually showing the widgets.

Remember that you have to show the containers containing a widget, in addition to the widget itself, before it will appear onscreen.

When a toplevel container is shown, it is immediately realized and mapped; other shown widgets are realized and mapped when their toplevel container is realized and mapped.

void Gtk::Widget::show_all | ( |  | ) |

Recursively shows a widget, and any child widgets (if the widget is a container).

virtual void Gtk::Widget::show_all_vfunc | ( |  | ) | `[protected, virtual]`

void Gtk::Widget::show_now | ( |  | ) |

Shows a widget.

If the widget is an unmapped toplevel widget (i.e. a Gtk::Window that has not yet been shown), enter the main loop and wait for the window to actually be mapped. Be careful; because the main loop is running, anything can happen during this function.

Glib::SignalProxy1< bool,GdkEventButton* > Gtk::Widget::signal_button_press_event | ( |  | ) |

Prototype:
  `bool on_my_button_press_event(GdkEventButton* event)`

Glib::SignalProxy1< bool,GdkEventButton* > Gtk::Widget::signal_button_release_event | ( |  | ) |

Prototype:
  `bool on_my_button_release_event(GdkEventButton* event)`

Glib::SignalProxy1< void,GParamSpec* > Gtk::Widget::signal_child_notify | ( |  | ) |

The child-notify signal is emitted for each child property that has changed on an object.

The signal's detail holds the property name.

Parameters:

  | pspec | The GParamSpec of the changed child property.

Prototype:
  `void on_my_child_notify(GParamSpec* pspec)`

Glib::SignalProxy1< bool,GdkEventClient* > Gtk::Widget::signal_client_event | ( |  | ) |

Prototype:
  `bool on_my_client_event(GdkEventClient* event)`

Glib::SignalProxy0< void > Gtk::Widget::signal_composited_changed | ( |  | ) |

Prototype:
  `void on_my_composited_changed()`

Glib::SignalProxy1< bool,GdkEventConfigure* > Gtk::Widget::signal_configure_event | ( |  | ) |

Prototype:
  `bool on_my_configure_event(GdkEventConfigure* event)`

Glib::SignalProxy1< bool,GdkEventExpose* > Gtk::Widget::signal_damage_event | ( |  | ) |

Prototype:
  `bool on_my_damage_event(GdkEventExpose* event)`

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_delete_event | ( |  | ) |

The delete_event signal is emitted if a user requests that a toplevel window is closed.

The default handler for this signal hides the window.

Parameters:

  | event | the event which triggered this signal.

Returns:
  true to stop other handlers from being invoked for the event, or false to propagate the event. further.

Prototype:
  `bool on_my_delete_event(GdkEventAny* event)`

Glib::SignalProxy1<void,TextDirection> Gtk::Widget::signal_direction_changed | ( |  | ) |

Prototype:
  `void on_my_direction_changed(TextDirection direction)`

Glib::SignalProxy1<void,const Glib::RefPtr<Gdk::DragContext>&> Gtk::Widget::signal_drag_begin | ( |  | ) |

The drag_begin signal is emitted on the drag source when a drag is started.

A typical reason to connect to this signal is to set up a custom drag icon with drag_source_set_icon().

Parameters:

  | context | the drag context

Prototype:
  `void on_my_drag_begin(const Glib::RefPtr<Gdk::DragContext>& context)`

Glib::SignalProxy1<void,const Glib::RefPtr<Gdk::DragContext>&> Gtk::Widget::signal_drag_data_delete | ( |  | ) |

The drag_data_delete signal is emitted on the drag source when a drag with the action Gdk::ACTION_MOVE is successfully completed.

The signal handler is responsible for deleting the data that has been dropped. What "delete" means, depends on the context of the drag operation.

Parameters:

  | context | the drag context.

Prototype:
  `void on_my_drag_data_delete(const Glib::RefPtr<Gdk::DragContext>& context)`

Glib::SignalProxy4<void,const Glib::RefPtr<Gdk::DragContext>&,SelectionData&,guint,guint> Gtk::Widget::signal_drag_data_get | ( |  | ) |

The drag_data_get signal is emitted on the drag source when the drop site requests the data which is dragged.

It is the responsibility of the signal handler to fill data with the data in the format which is indicated by info. See SelectionData::set() and SelectionData::set_text().

Parameters:

  | context,: | the drag context.
  | selection_data | the SelectionData to be filled with the dragged data.
  | info | the info that has been registered with the target in the TargetList.
  | time | the timestamp at which the data was requested.

Prototype:
  `void on_my_drag_data_get(const Glib::RefPtr<Gdk::DragContext>& context, SelectionData& selection_data, guint info, guint time)`

Glib::SignalProxy6<void,const Glib::RefPtr<Gdk::DragContext>&,int,int,const SelectionData&,guint,guint> Gtk::Widget::signal_drag_data_received | ( |  | ) |

The drag_data_received signal is emitted on the drop site when the dragged data has been received.

If the data was received in order to determine whether the drop will be accepted, the handler is expected to call drag_status() and <emphasis>not</emphasis> finish the drag. If the data was received in response to a drag_drop signal (and this is the last target to be received), the handler for this signal is expected to process the received data and then call drag_finish(), setting the success parameter depending on whether the data was processed successfully.

The handler may inspect and modify ->action before calling gtk_drag_finish(), e.g. to implement GdkACTION_ASK.

Parameters:

  | drag_context | the drag context
  | x | where the drop happened
  | y | where the drop happened
  | data | the received data
  | info | the info that has been registered with the target in the TargetList.
  | time | the timestamp at which the data was received.

Prototype:
  `void on_my_drag_data_received(const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, const SelectionData& selection_data, guint info, guint time)`

Glib::SignalProxy4<bool,const Glib::RefPtr<Gdk::DragContext>&,int,int,guint> Gtk::Widget::signal_drag_drop | ( |  | ) |

The drag_drop signal is emitted on the drop site when the user drops the data onto the widget.

The signal handler must determine whether the cursor position is in a drop zone or not. If it is not in a drop zone, it returns false and no further processing is necessary. Otherwise, the handler returns true. In this case, the handler must ensure that gtk_drag_finish() is called to let the source know that the drop is done. The call to gtk_drag_finish() can be done either directly or in a drag_data_received handler which gets triggered by calling drop_get_data() to receive the data for one or more of the supported targets.

Parameters:

  | context | the drag context.
  | x | the x coordinate of the current cursor position.
  | y | the y coordinate of the current cursor position.
  | time,: | the timestamp of the motion event.

Returns:
  whether the cursor position is in a drop zone

Prototype:
  `bool on_my_drag_drop(const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, guint time)`

Glib::SignalProxy1<void,const Glib::RefPtr<Gdk::DragContext>&> Gtk::Widget::signal_drag_end | ( |  | ) |

The drag_end signal is emitted on the drag source when a drag is finished.

A typical reason to connect to this signal is to undo things done in the drag-begin signal handler.

Parameters:

  | context | the drag context.

Prototype:
  `void on_my_drag_end(const Glib::RefPtr<Gdk::DragContext>& context)`

Glib::SignalProxy2<bool,const Glib::RefPtr<Gdk::DragContext>&,DragResult> Gtk::Widget::signal_drag_failed | ( |  | ) |

Prototype:
  `bool on_my_drag_failed(const Glib::RefPtr<Gdk::DragContext>& context, DragResult result)`

Glib::SignalProxy2<void,const Glib::RefPtr<Gdk::DragContext>&,guint> Gtk::Widget::signal_drag_leave | ( |  | ) |

The drag_leave signal is emitted on the drop site when the cursor leaves the widget.

A typical reason to connect to this signal is to undo things done in the drag_motion signal handler, e.g. undo highlighting with drag_unhighlight().

Parameters:

  | context | the drag context.
  | time | the timestamp of the motion event.

Prototype:
  `void on_my_drag_leave(const Glib::RefPtr<Gdk::DragContext>& context, guint time)`

Glib::SignalProxy4<bool,const Glib::RefPtr<Gdk::DragContext>&,int,int,guint> Gtk::Widget::signal_drag_motion | ( |  | ) |

The drag_motion signal is emitted on the drop site when the user moves the cursor over the widget during a drag.

The signal handler must determine whether the cursor position is in a drop zone or not. If it is not in a drop zone, it returns false and no further processing is necessary. Otherwise, the handler returns true. In this case, the handler is responsible for providing the necessary information for displaying feedback to the user, by calling drag_status(). If the decision whether the drop will be accepted or rejected can't be made based solely on the cursor position and the type of the data, the handler may inspect the dragged data by calling drag_get_data() and defer the drag_status() call to the drag_data_received handler.

Note that there is no drag_enter signal. The drag receiver has to keep track of whether he has received any drag_motion signals since the last drag_leave and if not, treat the drag_motion signal as an "enter" signal. Upon an "enter", the handler will typically highlight the drop site with drag_highlight().

Parameters:

  | context | the drag context.
  | x | the x coordinate of the current cursor position.
  | y | the y coordinate of the current cursor position.
  | time | the timestamp of the motion event.

Returns:
  whether the cursor position is in a drop zone.

Prototype:
  `bool on_my_drag_motion(const Glib::RefPtr<Gdk::DragContext>& context, int x, int y, guint time)`

Glib::SignalProxy1< bool,GdkEventCrossing* > Gtk::Widget::signal_enter_notify_event | ( |  | ) |

Prototype:
  `bool on_my_enter_notify_event(GdkEventCrossing* event)`

Glib::SignalProxy1< bool,GdkEvent* > Gtk::Widget::signal_event | ( |  | ) |

Prototype:
  `bool on_my_event(GdkEvent* event)`

Glib::SignalProxy1< void,GdkEvent* > Gtk::Widget::signal_event_after | ( |  | ) |

Prototype:
  `void on_my_event_after(GdkEvent* event)`

Glib::SignalProxy1< bool,GdkEventExpose* > Gtk::Widget::signal_expose_event | ( |  | ) |

Prototype:
  `bool on_my_expose_event(GdkEventExpose* event)`

Glib::SignalProxy1<bool,DirectionType> Gtk::Widget::signal_focus | ( |  | ) |

Prototype:
  `bool on_my_focus(DirectionType direction)`

Glib::SignalProxy1< bool,GdkEventFocus* > Gtk::Widget::signal_focus_in_event | ( |  | ) |

Prototype:
  `bool on_my_focus_in_event(GdkEventFocus* event)`

Glib::SignalProxy1< bool,GdkEventFocus* > Gtk::Widget::signal_focus_out_event | ( |  | ) |

Prototype:
  `bool on_my_focus_out_event(GdkEventFocus* event)`

Glib::SignalProxy0<Glib::RefPtr<Atk::Object>> Gtk::Widget::signal_get_accessible | ( |  | ) |

Deprecated:
  This should never have been in the API. It was never meaningful.

Prototype:
  `Glib::RefPtr<Atk::Object> on_my_get_accessible()`

Glib::SignalProxy1< bool,GdkEventGrabBroken* > Gtk::Widget::signal_grab_broken_event | ( |  | ) |

Prototype:
  `bool on_my_grab_broken_event(GdkEventGrabBroken* event)`

Glib::SignalProxy0< void > Gtk::Widget::signal_grab_focus | ( |  | ) |

Prototype:
  `void on_my_grab_focus()`

Glib::SignalProxy1< void,bool > Gtk::Widget::signal_grab_notify | ( |  | ) |

Prototype:
  `void on_my_grab_notify(bool was_grabbed)`

Glib::SignalProxy0< void > Gtk::Widget::signal_hide | ( |  | ) |

Prototype:
  `void on_my_hide()`

Glib::SignalProxy1<void,Widget*> Gtk::Widget::signal_hierarchy_changed | ( |  | ) |

Prototype:
  `void on_my_hierarchy_changed(Widget* previous_toplevel)`

Glib::SignalProxy1< bool,GdkEventKey* > Gtk::Widget::signal_key_press_event | ( |  | ) |

Prototype:
  `bool on_my_key_press_event(GdkEventKey* event)`

Glib::SignalProxy1< bool,GdkEventKey* > Gtk::Widget::signal_key_release_event | ( |  | ) |

Prototype:
  `bool on_my_key_release_event(GdkEventKey* event)`

Glib::SignalProxy1< bool,GdkEventCrossing* > Gtk::Widget::signal_leave_notify_event | ( |  | ) |

Prototype:
  `bool on_my_leave_notify_event(GdkEventCrossing* event)`

Glib::SignalProxy0< void > Gtk::Widget::signal_map | ( |  | ) |

Prototype:
  `void on_my_map()`

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_map_event | ( |  | ) |

Prototype:
  `bool on_my_map_event(GdkEventAny* event)`

Glib::SignalProxy1< bool,bool > Gtk::Widget::signal_mnemonic_activate | ( |  | ) |

Prototype:
  `bool on_my_mnemonic_activate(bool group_cycling)`

Glib::SignalProxy1< bool,GdkEventMotion* > Gtk::Widget::signal_motion_notify_event | ( |  | ) |

Prototype:
  `bool on_my_motion_notify_event(GdkEventMotion* event)`

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_no_expose_event | ( |  | ) |

Prototype:
  `bool on_my_no_expose_event(GdkEventAny* event)`

Glib::SignalProxy1<void,Widget*> Gtk::Widget::signal_parent_changed | ( |  | ) |

Prototype:
  `void on_my_parent_changed(Widget* previous_parent)`

Glib::SignalProxy0< bool > Gtk::Widget::signal_popup_menu | ( |  | ) |

Prototype:
  `bool on_my_popup_menu()`

Glib::SignalProxy1< bool,GdkEventProperty* > Gtk::Widget::signal_property_notify_event | ( |  | ) |

Prototype:
  `bool on_my_property_notify_event(GdkEventProperty* event)`

Glib::SignalProxy1< bool,GdkEventProximity* > Gtk::Widget::signal_proximity_in_event | ( |  | ) |

Prototype:
  `bool on_my_proximity_in_event(GdkEventProximity* event)`

Glib::SignalProxy1< bool,GdkEventProximity* > Gtk::Widget::signal_proximity_out_event | ( |  | ) |

Prototype:
  `bool on_my_proximity_out_event(GdkEventProximity* event)`

Glib::SignalProxy4<bool,int,int,bool,const Glib::RefPtr<Tooltip>&> Gtk::Widget::signal_query_tooltip | ( |  | ) |

Prototype:
  `bool on_my_query_tooltip(int x, int y, bool keyboard_tooltip, const Glib::RefPtr<Tooltip>& tooltip)`

Glib::SignalProxy0< void > Gtk::Widget::signal_realize | ( |  | ) |

Prototype:
  `void on_my_realize()`

Glib::SignalProxy1<void,const Glib::RefPtr<Gdk::Screen>&> Gtk::Widget::signal_screen_changed | ( |  | ) |

Prototype:
  `void on_my_screen_changed(const Glib::RefPtr<Gdk::Screen>& previous_screen)`

Glib::SignalProxy1< bool,GdkEventScroll* > Gtk::Widget::signal_scroll_event | ( |  | ) |

Prototype:
  `bool on_my_scroll_event(GdkEventScroll* event)`

Glib::SignalProxy1< bool,GdkEventSelection* > Gtk::Widget::signal_selection_clear_event | ( |  | ) |

Prototype:
  `bool on_my_selection_clear_event(GdkEventSelection* event)`

Glib::SignalProxy3<void,SelectionData&,guint,guint> Gtk::Widget::signal_selection_get | ( |  | ) |

Prototype:
  `void on_my_selection_get(SelectionData& selection_data, guint info, guint time)`

Glib::SignalProxy1< bool,GdkEventSelection* > Gtk::Widget::signal_selection_notify_event | ( |  | ) |

Prototype:
  `bool on_my_selection_notify_event(GdkEventSelection* event)`

Glib::SignalProxy2<void,const SelectionData&,guint> Gtk::Widget::signal_selection_received | ( |  | ) |

Prototype:
  `void on_my_selection_received(const SelectionData& selection_data, guint time)`

Glib::SignalProxy1< bool,GdkEventSelection* > Gtk::Widget::signal_selection_request_event | ( |  | ) |

Prototype:
  `bool on_my_selection_request_event(GdkEventSelection* event)`

Glib::SignalProxy0< void > Gtk::Widget::signal_show | ( |  | ) |

Prototype:
  `void on_my_show()`

Glib::SignalProxy1<void,Allocation&> Gtk::Widget::signal_size_allocate | ( |  | ) |

Prototype:
  `void on_my_size_allocate(Allocation& allocation)`

Glib::SignalProxy1<void,Requisition*> Gtk::Widget::signal_size_request | ( |  | ) |

Prototype:
  `void on_my_size_request(Requisition* requisition)`

Glib::SignalProxy1<void,Gtk::StateType> Gtk::Widget::signal_state_changed | ( |  | ) |

Prototype:
  `void on_my_state_changed(Gtk::StateType previous_state)`

Glib::SignalProxy1<void,const Glib::RefPtr<Gtk::Style>&> Gtk::Widget::signal_style_changed | ( |  | ) |

The style-set signal is emitted when a new style has been set on a widget.

Note that style-modifying functions like modify_base() also cause this signal to be emitted.

Parameters:

  | previous_style | the previous style, or an empty RefPtr if the widget just got its initial style.

Prototype:
  `void on_my_style_changed(const Glib::RefPtr<Gtk::Style>& previous_style)`

Glib::SignalProxy0< void > Gtk::Widget::signal_unmap | ( |  | ) |

Prototype:
  `void on_my_unmap()`

Glib::SignalProxy1< bool,GdkEventAny* > Gtk::Widget::signal_unmap_event | ( |  | ) |

Prototype:
  `bool on_my_unmap_event(GdkEventAny* event)`

Glib::SignalProxy0< void > Gtk::Widget::signal_unrealize | ( |  | ) |

Prototype:
  `void on_my_unrealize()`

Glib::SignalProxy1< bool,GdkEventVisibility* > Gtk::Widget::signal_visibility_notify_event | ( |  | ) |

Prototype:
  `bool on_my_visibility_notify_event(GdkEventVisibility* event)`

Glib::SignalProxy1< bool,GdkEventWindowState* > Gtk::Widget::signal_window_state_event | ( |  | ) |

Prototype:
  `bool on_my_window_state_event(GdkEventWindowState* event)`

void Gtk::Widget::size_allocate | ( | const Allocation& | allocation | ) |

This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets.

Parameters:

  | allocation | Position and size to be allocated to widget.

void Gtk::Widget::size_request | ( | const Requisition& | requisition | ) |

This function is typically used when implementing a Gtk::Container subclass.

Obtains the preferred size of a widget. The container uses this information to arrange its child widgets and decide what size allocations to give them with size_allocate().

You can also call this function from an application, with some caveats. Most notably, getting a size request requires the widget to be associated with a screen, because font information may be needed. Multihead-aware applications should keep this in mind.

Also remember that the size request is not necessarily the size a widget will actually be allocated.

See also get_child_requisition().

Deprecated:
  Use size_request() const.

Parameters:

  | requisition | A Gtk::Requisition to be filled in.

Requisition Gtk::Widget::size_request | ( |  | ) | const

This function is typically used when implementing a Gtk::Container subclass.

Obtains the preferred size of a widget. The container uses this information to arrange its child widgets and decide what size allocations to give them with size_allocate().

You can also call this function from an application, with some caveats. Most notably, getting a size request requires the widget to be associated with a screen, because font information may be needed. Multihead-aware applications should keep this in mind.

Also remember that the size request is not necessarily the size a widget will actually be allocated.

See also get_child_requisition().

Returns:
  A Gtk::Requisition.

void Gtk::Widget::thaw_child_notify | ( |  | ) |

Reverts the effect of a previous call to freeze_child_notify().

This causes all queued Gtk::Widget::child-notify signals on widget to be emitted.

bool Gtk::Widget::translate_coordinates | ( | Widget& | dest_widget,
|  | int | src_x,
|  | int | src_y,
|  | int & | dest_x,
|  | int & | dest_y |
| ) |  |  |

Translate coordinates relative to src_widget's allocation to coordinates relative to dest_widget's allocations.

In order to perform this operation, both widgets must be realized, and must share a common toplevel.

Parameters:

  | dest_widget | A Gtk::Widget.
  | src_x | X position relative to src_widget.
  | src_y | Y position relative to src_widget.
  | dest_x | Location to store X position relative to dest_widget.
  | dest_y | Location to store Y position relative to dest_widget.

Returns:
  `false` if either widget was not realized, or there was no common ancestor. In this case, nothing is stored in * dest_x and * dest_y. Otherwise `true`.

void Gtk::Widget::trigger_tooltip_query | ( |  | ) |

Triggers a tooltip query on the display where the toplevel of widget is located.

See gtk_tooltip_trigger_tooltip_query() for more information.

Since gtkmm 2.12:

void Gtk::Widget::unmap | ( |  | ) |

This function is only for use in widget implementations.

Causes a widget to be unmapped if it's currently mapped.

void Gtk::Widget::unparent | ( |  | ) |

This function is only for use in widget implementations.

Should be called by implementations of the remove method on Gtk::Container, to dissociate a child from the container.

void Gtk::Widget::unrealize | ( |  | ) | `[protected]`

This function is only useful in widget implementations.

Causes a widget to be unrealized (frees all GDK resources associated with the widget, such as widget->window).

void Gtk::Widget::unset_base | ( | StateType | state | ) |

Undo the effect of previous calls to modify_base() for a particular state.

All other style values are left untouched. See also modify_style().

void Gtk::Widget::unset_bg | ( | StateType | state | ) |

Undo the effect of previous calls to modify_bg() for a particular state.

All other style values are left untouched. See also modify_style().

void Gtk::Widget::unset_composite_name | ( |  | ) |

void Gtk::Widget::unset_cursor | ( |  | ) |

See modify_cursor().

void Gtk::Widget::unset_fg | ( | StateType | state | ) |

Undo the effect of previous calls to modify_fg() for a particular state.

All other style values are left untouched. See also modify_style().

void Gtk::Widget::unset_flags | ( | WidgetFlags | flags | ) |

void Gtk::Widget::unset_font | ( |  | ) |

Undo the effect of previous calls to modify_font() for a particular state.

All other style values are left untouched. See also modify_style().

void Gtk::Widget::unset_input_shape_combine_mask | ( |  | ) |

void Gtk::Widget::unset_name | ( |  | ) |

void Gtk::Widget::unset_shape_combine_mask | ( |  | ) |

void Gtk::Widget::unset_style | ( |  | ) |

void Gtk::Widget::unset_text | ( | StateType | state | ) |

Undo the effect of previous calls to modify_text() for a particular state.

All other style values are left untouched. See also modify_style().

## Friends And Related Function Documentation

friend class Main`[friend]`

Gtk::Widget* wrap | ( | GtkWidget * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- widget.h